#ifndef  _KOR_FONT_DEF_H
#define _KOR_FONT_DEF_H


typedef unsigned char           GLANbyte;
typedef unsigned short int      GLANword;

GLANword ConvertExtKS_ ( GLANword Code );
GLANword ConvertKS_ ( GLANword code );

// color
typedef struct GLANcolor_
    {   GLANbyte r, g, b, a;  }      GLANcolor;

// hangul phoneme  
typedef struct GLANhanphnm_
    {
        GLANword final  :5;  // 
        GLANword medial :5;  // ߼
        GLANword initial:5;  // ʼ
        GLANword ident  :1;  // ù 1Ʈ
        
    }                           GLANhanphnm;
    

// definitions //////////////////////////////////////////////////////////////

#define GLAN_TEXTBOX_MAX_STR            4096

#define GLAN_TEXTBOX_NONE               0x00
#define GLAN_TEXTBOX_DRAW_BOX           0x01
#define GLAN_TEXTBOX_DRAW_SPACES        0x02
#define GLAN_TEXTBOX_WRAP_SPACES        0x04
#define GLAN_TEXTBOX_DRAW_BACKGROUND    0x08


// macros ///////////////////////////////////////////////////////////////////

#define     glanHighByte(w)                 (GLANbyte)(w >> 8)
#define     glanLowByte(w)                  (GLANbyte)(w)
#define     glanWord(h,l)                   (GLANword)(((GLANbyte)h << 8)|(GLANbyte)(l))

#define     glanGetHanIdent(code)           (((GLANhanphnm*)&code)->ident)
#define     glanGetHanInitial(code)         (((GLANhanphnm*)&code)->initial)
#define     glanGetHanMedial(code)          (((GLANhanphnm*)&code)->medial)
#define     glanGetHanFinal(code)           (((GLANhanphnm*)&code)->final)

#if defined(__GLAN_EXTEND_KS)
#   define  glanGetCodeEXTKS(pos)           (glantCodeKS_[pos])
#   define  glanGetCodeKS(pos)              (glantCodeKS_[pos+8822])
#else    // __GLAN_EXTEND_KS
#   define  glanGetCodeEXTKS(pos)           (0)
#   define  glanGetCodeKS(pos)              (glantCodeKS_[pos])
#endif   // __GLAN_EXTEND_KS


#define     glanSetColor(c, rIn, gIn, bIn, aIn) \
    c.r = rIn; \
    c.g = gIn; \
    c.b = bIn; \
    c.a = aIn


// GLANT - glan table ///////////////////////////////////////////////////////

const GLANbyte glantCodeFont_[3][32] = {
    // ʼ
    {  0,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
      15, 16, 17, 18, 19,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },

    // ߼
    {  0,  0,  0,  1,  2,  3,  4,  5,  0,  0,  6,  7,  8,  9, 10, 11,
       0,  0, 12, 13, 14, 15, 16, 17,  0,  0, 18, 19, 20, 21,  0,  0 },

    // 
    {  0,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
      15, 16,  0, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27,  0,  0 }
};


const GLANbyte glantFormInitial_[2][22] = {
    /*    ߼  ʼ .. */
    {  0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3, 3, 3, 1, 2, 4, 4, 4, 2, 1, 3, 0  },

    /*    ߼  ʼ .. */
    {  0, 5, 5, 5, 5, 5, 5, 5, 5, 6, 7, 7, 7, 6, 6, 7, 7, 7, 6, 6, 7, 5  }
};
    

const GLANbyte glantFormMedial_[2][20] = {
    /*    ʼ  ߼ .. */
    {  0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1  },

    /*    ʼ  ߼ .. */    
    {  0, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 2, 3, 3, 3  }
};

const GLANbyte glantFormFinal_[22] =
    /* ߼   .. */
    {  0, 0, 2, 0, 2, 1, 2, 1, 2, 3, 0, 2, 1, 3, 3, 1, 2, 1, 3, 3, 1, 1  };


//  ѱ  51  ڵ
const GLANword glantSingleKSSM_[51] = {
        0x8841, 0x8C41, 0x8444, 0x9041, 0x8446, 0x8447, 0x9441, 0x9841,
        0x9C41, 0x844A, 0x844B, 0x844C, 0x844D, 0x844E, 0x844F, 0x8450,
        0xA041, 0xA441, 0xA841, 0x8454, 0xAC41, 0xB041, 0xB441, 0xB841,
        0xBC41, 0xC041, 0xC441, 0xC841, 0xCC41, 0xD041, 0x8461, 0x8481,
        0x84A1, 0x84C1, 0x84E1, 0x8541, 0x8561, 0x8581, 0x85A1, 0x85C1,
        0x85E1, 0x8641, 0x8661, 0x8681, 0x86A1, 0x86C1, 0x86E1, 0x8741,
        0x8761, 0x8781, 0x87A1
};

// Ȯϼ 8822 
// ϼ 2350 
//#define __GLAN_EXTEND_KScd 

#if defined(__GLAN_EXTEND_KS)
#   define  GLAN_NUMBER_KS_    11172
#else    // __GLAN_EXTEND_KS
#   define  GLAN_NUMBER_KS_    2350
#endif   // __GLAN_EXTEND_KS

const GLANword glantCodeKS_[GLAN_NUMBER_KS_] = {
#if defined(__GLAN_EXTEND_KS)
        0x8863, 0x8864, 0x8866, 0x8867, 0x886C, 0x886D, 0x886E, 0x886F,
        0x8870, 0x887A, 0x8883, 0x8884, 0x8886, 0x8887, 0x8888, 0x888A,
        0x888B, 0x888C, 0x888D, 0x888E, 0x888F, 0x8890, 0x8894, 0x8898,
        0x8899, 0x889A, 0x889B, 0x889C, 0x889D, 0x88A3, 0x88A4, 0x88A6,
        0x88A7, 0x88A8, 0x88AA, 0x88AB, 0x88AC, 0x88AD, 0x88AE, 0x88AF,
        0x88B0, 0x88B1, 0x88B3, 0x88B4, 0x88B6, 0x88B8, 0x88B9, 0x88BA,
        0x88BB, 0x88BC, 0x88BD, 0x88C2, 0x88C3, 0x88C4, 0x88C6, 0x88C7,
        0x88C8, 0x88CA, 0x88CB, 0x88CC, 0x88CD, 0x88CE, 0x88CF, 0x88D0,
        0x88D1, 0x88D3, 0x88D4, 0x88D5, 0x88D6, 0x88D7, 0x88D8, 0x88D9,
        0x88DA, 0x88DB, 0x88DC, 0x88DD, 0x88E3, 0x88E4, 0x88E6, 0x88E7,
        0x88EA, 0x88EC, 0x88ED, 0x88EE, 0x88EF, 0x88F0, 0x88F4, 0x88F9,
        0x88FA, 0x8942, 0x8943, 0x8944, 0x8946, 0x8947, 0x8948, 0x894A,
        0x894B, 0x894C, 0x894D, 0x894E, 0x894F, 0x8950, 0x8954, 0x8958,
        0x8959, 0x895A, 0x895B, 0x895C, 0x895D, 0x8964, 0x8966, 0x8967,
        0x896A, 0x896B, 0x896C, 0x896D, 0x896E, 0x896F, 0x8970, 0x8974,
        0x8978, 0x8979, 0x897A, 0x897C, 0x897D, 0x8982, 0x8983, 0x8984,
        0x8986, 0x8987, 0x8988, 0x898A, 0x898B, 0x898C, 0x898D, 0x898E,
        0x898F, 0x8990, 0x8991, 0x8994, 0x8996, 0x8997, 0x8998, 0x8999,
        0x899A, 0x899B, 0x899C, 0x899D, 0x89A3, 0x89A4, 0x89A6, 0x89A7,
        0x89AA, 0x89AC, 0x89AE, 0x89AF, 0x89B4, 0x89B6, 0x89B9, 0x89BA,
        0x89BB, 0x89BC, 0x89BD, 0x89C3, 0x89C4, 0x89C6, 0x89C7, 0x89C8,
        0x89CA, 0x89CC, 0x89CD, 0x89CE, 0x89CF, 0x89D0, 0x89D4, 0x89D6,
        0x89D8, 0x89D9, 0x89DA, 0x89DB, 0x89DC, 0x89DD, 0x89E2, 0x89E3,
        0x89E4, 0x89E6, 0x89E7, 0x89E8, 0x89EA, 0x89EB, 0x89EC, 0x89ED,
        0x89EE, 0x89EF, 0x89F0, 0x89F3, 0x89F4, 0x89F5, 0x89F8, 0x89F9,
        0x89FA, 0x89FB, 0x89FC, 0x89FD, 0x8A43, 0x8A44, 0x8A46, 0x8A47,
        0x8A48, 0x8A4A, 0x8A4B, 0x8A4C, 0x8A4D, 0x8A4E, 0x8A4F, 0x8A50,
        0x8A54, 0x8A56, 0x8A58, 0x8A59, 0x8A5A, 0x8A5B, 0x8A5C, 0x8A5D,
        0x8A62, 0x8A63, 0x8A64, 0x8A66, 0x8A67, 0x8A68, 0x8A6A, 0x8A6B,
        0x8A6C, 0x8A6D, 0x8A6E, 0x8A6F, 0x8A70, 0x8A71, 0x8A74, 0x8A76,
        0x8A77, 0x8A78, 0x8A79, 0x8A7A, 0x8A7B, 0x8A7C, 0x8A7D, 0x8A83,
        0x8A84, 0x8A86, 0x8A87, 0x8A8C, 0x8A8D, 0x8A8E, 0x8A8F, 0x8A94,
        0x8A96, 0x8A99, 0x8A9A, 0x8A9B, 0x8A9C, 0x8A9D, 0x8AA3, 0x8AA4,
        0x8AA6, 0x8AA7, 0x8AA8, 0x8AAA, 0x8AAB, 0x8AAC, 0x8AAD, 0x8AAE,
        0x8AAF, 0x8AB0, 0x8AB1, 0x8AB3, 0x8AB4, 0x8AB5, 0x8AB8, 0x8AB9,
        0x8ABA, 0x8ABB, 0x8ABC, 0x8ABD, 0x8AC2, 0x8AC3, 0x8AC4, 0x8AC5,
        0x8AC6, 0x8AC7, 0x8AC8, 0x8AC9, 0x8ACA, 0x8ACB, 0x8ACC, 0x8ACD,
        0x8ACE, 0x8ACF, 0x8AD0, 0x8AD1, 0x8AD3, 0x8AD4, 0x8AD6, 0x8AD7,
        0x8AD8, 0x8AD9, 0x8ADA, 0x8ADB, 0x8ADC, 0x8ADD, 0x8AE3, 0x8AE4,
        0x8AE6, 0x8AE7, 0x8AE8, 0x8AEA, 0x8AEB, 0x8AEC, 0x8AED, 0x8AEE,
        0x8AEF, 0x8AF0, 0x8AF4, 0x8AF6, 0x8AF7, 0x8AF8, 0x8AF9, 0x8AFA,
        0x8AFB, 0x8AFC, 0x8AFD, 0x8B42, 0x8B43, 0x8B44, 0x8B46, 0x8B47,
        0x8B48, 0x8B4A, 0x8B4B, 0x8B4C, 0x8B4D, 0x8B4E, 0x8B4F, 0x8B50,
        0x8B51, 0x8B53, 0x8B54, 0x8B55, 0x8B56, 0x8B57, 0x8B58, 0x8B59,
        0x8B5A, 0x8B5B, 0x8B5C, 0x8B5D, 0x8B63, 0x8B64, 0x8B66, 0x8B67,
        0x8B6B, 0x8B6C, 0x8B6D, 0x8B6E, 0x8B6F, 0x8B70, 0x8B74, 0x8B76,
        0x8B78, 0x8B79, 0x8B7A, 0x8B7B, 0x8B7C, 0x8B7D, 0x8B82, 0x8B83,
        0x8B84, 0x8B85, 0x8B86, 0x8B87, 0x8B88, 0x8B89, 0x8B8A, 0x8B8B,
        0x8B8C, 0x8B8D, 0x8B8E, 0x8B8F, 0x8B90, 0x8B91, 0x8B93, 0x8B94,
        0x8B95, 0x8B96, 0x8B97, 0x8B98, 0x8B99, 0x8B9A, 0x8B9B, 0x8B9C,
        0x8B9D, 0x8BA3, 0x8BA4, 0x8BA6, 0x8BA7, 0x8BAA, 0x8BAC, 0x8BAD,
        0x8BAE, 0x8BAF, 0x8BB0, 0x8BB4, 0x8BB6, 0x8BB9, 0x8BBA, 0x8BBB,
        0x8BBD, 0x8C64, 0x8C66, 0x8C67, 0x8C68, 0x8C6A, 0x8C6C, 0x8C6D,
        0x8C6E, 0x8C6F, 0x8C70, 0x8C74, 0x8C78, 0x8C79, 0x8C7A, 0x8C7C,
        0x8C7D, 0x8C83, 0x8C84, 0x8C86, 0x8C87, 0x8C88, 0x8C8A, 0x8C8B,
        0x8C8C, 0x8C8D, 0x8C8E, 0x8C8F, 0x8C90, 0x8C94, 0x8C98, 0x8C99,
        0x8C9A, 0x8C9B, 0x8C9C, 0x8C9D, 0x8CA3, 0x8CA4, 0x8CA5, 0x8CA6,
        0x8CA7, 0x8CA8, 0x8CAA, 0x8CAB, 0x8CAC, 0x8CAD, 0x8CAE, 0x8CAF,
        0x8CB0, 0x8CB1, 0x8CB3, 0x8CB4, 0x8CB5, 0x8CB6, 0x8CB7, 0x8CB8,
        0x8CB9, 0x8CBA, 0x8CBB, 0x8CBC, 0x8CBD, 0x8CC1, 0x8CC2, 0x8CC3,
        0x8CC4, 0x8CC5, 0x8CC6, 0x8CC7, 0x8CC8, 0x8CC9, 0x8CCA, 0x8CCB,
        0x8CCC, 0x8CCD, 0x8CCE, 0x8CCF, 0x8CD0, 0x8CD1, 0x8CD3, 0x8CD4,
        0x8CD5, 0x8CD6, 0x8CD7, 0x8CD8, 0x8CD9, 0x8CDA, 0x8CDB, 0x8CDC,
        0x8CDD, 0x8CE4, 0x8CE6, 0x8CE7, 0x8CE8, 0x8CEA, 0x8CEB, 0x8CEC,
        0x8CED, 0x8CEE, 0x8CEF, 0x8CF0, 0x8CF4, 0x8CF8, 0x8CF9, 0x8CFA,
        0x8CFB, 0x8CFC, 0x8CFD, 0x8D43, 0x8D44, 0x8D46, 0x8D47, 0x8D48,
        0x8D49, 0x8D4A, 0x8D4B, 0x8D4C, 0x8D4D, 0x8D4E, 0x8D4F, 0x8D50,
        0x8D53, 0x8D54, 0x8D56, 0x8D58, 0x8D59, 0x8D5A, 0x8D5B, 0x8D5C,
        0x8D5D, 0x8D62, 0x8D63, 0x8D64, 0x8D66, 0x8D67, 0x8D68, 0x8D6A,
        0x8D6B, 0x8D6C, 0x8D6D, 0x8D6E, 0x8D6F, 0x8D70, 0x8D71, 0x8D73,
        0x8D74, 0x8D77, 0x8D78, 0x8D79, 0x8D7A, 0x8D7C, 0x8D7D, 0x8D82,
        0x8D83, 0x8D84, 0x8D85, 0x8D86, 0x8D87, 0x8D88, 0x8D89, 0x8D8A,
        0x8D8B, 0x8D8C, 0x8D8D, 0x8D8E, 0x8D8F, 0x8D90, 0x8D91, 0x8D93,
        0x8D94, 0x8D95, 0x8D96, 0x8D97, 0x8D98, 0x8D99, 0x8D9A, 0x8D9B,
        0x8D9C, 0x8D9D, 0x8DA3, 0x8DA4, 0x8DA6, 0x8DA8, 0x8DAA, 0x8DAB,
        0x8DAC, 0x8DAD, 0x8DAE, 0x8DAF, 0x8DB0, 0x8DB4, 0x8DB6, 0x8DBA,
        0x8DBB, 0x8DBC, 0x8DBD, 0x8DC3, 0x8DC4, 0x8DC5, 0x8DC6, 0x8DC7,
        0x8DC8, 0x8DCA, 0x8DCB, 0x8DCC, 0x8DCD, 0x8DCE, 0x8DCF, 0x8DD0,
        0x8DD1, 0x8DD3, 0x8DD4, 0x8DD5, 0x8DD8, 0x8DD9, 0x8DDA, 0x8DDB,
        0x8DDC, 0x8DDD, 0x8DE3, 0x8DE4, 0x8DE5, 0x8DE6, 0x8DE7, 0x8DE8,
        0x8DE9, 0x8DEA, 0x8DEB, 0x8DEC, 0x8DED, 0x8DEE, 0x8DEF, 0x8DF0,
        0x8DF1, 0x8DF3, 0x8DF4, 0x8DF5, 0x8DF6, 0x8DF8, 0x8DF9, 0x8DFA,
        0x8DFB, 0x8DFC, 0x8DFD, 0x8E42, 0x8E43, 0x8E44, 0x8E46, 0x8E47,
        0x8E48, 0x8E4A, 0x8E4B, 0x8E4C, 0x8E4D, 0x8E4E, 0x8E4F, 0x8E50,
        0x8E54, 0x8E55, 0x8E56, 0x8E58, 0x8E59, 0x8E5A, 0x8E5B, 0x8E5C,
        0x8E5D, 0x8E62, 0x8E63, 0x8E64, 0x8E65, 0x8E66, 0x8E67, 0x8E68,
        0x8E69, 0x8E6A, 0x8E6B, 0x8E6C, 0x8E6D, 0x8E6E, 0x8E6F, 0x8E70,
        0x8E71, 0x8E73, 0x8E74, 0x8E75, 0x8E76, 0x8E77, 0x8E78, 0x8E79,
        0x8E7A, 0x8E7B, 0x8E7C, 0x8E7D, 0x8E83, 0x8E84, 0x8E86, 0x8E87,
        0x8E88, 0x8E8A, 0x8E8B, 0x8E8C, 0x8E8D, 0x8E8E, 0x8E8F, 0x8E94,
        0x8E96, 0x8E99, 0x8E9A, 0x8E9B, 0x8E9C, 0x8E9D, 0x8EA2, 0x8EA3,
        0x8EA4, 0x8EA5, 0x8EA6, 0x8EA7, 0x8EA8, 0x8EAA, 0x8EAB, 0x8EAC,
        0x8EAD, 0x8EAE, 0x8EAF, 0x8EB0, 0x8EB1, 0x8EB3, 0x8EB4, 0x8EB5,
        0x8EB8, 0x8EB9, 0x8EBA, 0x8EBB, 0x8EBC, 0x8EBD, 0x8EC3, 0x8EC4,
        0x8EC6, 0x8EC7, 0x8EC8, 0x8ECA, 0x8ECB, 0x8ECC, 0x8ECD, 0x8ECE,
        0x8ECF, 0x8ED0, 0x8ED4, 0x8ED5, 0x8ED7, 0x8ED8, 0x8ED9, 0x8EDA,
        0x8EDB, 0x8EDC, 0x8EDD, 0x8EE2, 0x8EE3, 0x8EE4, 0x8EE6, 0x8EE7,
        0x8EE8, 0x8EEA, 0x8EEB, 0x8EEC, 0x8EED, 0x8EEE, 0x8EEF, 0x8EF0,
        0x8EF4, 0x8EF5, 0x8EF6, 0x8EF7, 0x8EF8, 0x8EF9, 0x8EFA, 0x8EFB,
        0x8EFC, 0x8EFD, 0x8F42, 0x8F43, 0x8F44, 0x8F45, 0x8F46, 0x8F47,
        0x8F48, 0x8F49, 0x8F4A, 0x8F4B, 0x8F4C, 0x8F4D, 0x8F4E, 0x8F4F,
        0x8F50, 0x8F51, 0x8F53, 0x8F54, 0x8F55, 0x8F56, 0x8F57, 0x8F58,
        0x8F59, 0x8F5A, 0x8F5B, 0x8F5C, 0x8F5D, 0x8F63, 0x8F64, 0x8F66,
        0x8F68, 0x8F6A, 0x8F6C, 0x8F6D, 0x8F6E, 0x8F6F, 0x8F74, 0x8F76,
        0x8F78, 0x8F79, 0x8F7A, 0x8F7C, 0x8F7D, 0x8F81, 0x8F82, 0x8F83,
        0x8F84, 0x8F85, 0x8F86, 0x8F87, 0x8F88, 0x8F89, 0x8F8A, 0x8F8B,
        0x8F8C, 0x8F8D, 0x8F8E, 0x8F8F, 0x8F90, 0x8F91, 0x8F93, 0x8F94,
        0x8F95, 0x8F96, 0x8F97, 0x8F98, 0x8F99, 0x8F9A, 0x8F9B, 0x8F9C,
        0x8F9D, 0x8FA3, 0x8FA4, 0x8FA6, 0x8FA7, 0x8FA8, 0x8FAA, 0x8FAB,
        0x8FAC, 0x8FAD, 0x8FAE, 0x8FAF, 0x8FB0, 0x8FB4, 0x8FB6, 0x8FB8,
        0x8FB9, 0x8FBA, 0x8FBB, 0x8FBC, 0x8FBD, 0x9064, 0x9066, 0x9067,
        0x906C, 0x906D, 0x906E, 0x906F, 0x9070, 0x9074, 0x907A, 0x907C,
        0x9083, 0x9084, 0x9086, 0x9087, 0x9088, 0x908A, 0x908B, 0x908C,
        0x908D, 0x908E, 0x908F, 0x9090, 0x9094, 0x9098, 0x9099, 0x909A,
        0x909B, 0x909C, 0x909D, 0x90A3, 0x90A4, 0x90A6, 0x90A7, 0x90A8,
        0x90AA, 0x90AB, 0x90AC, 0x90AD, 0x90AE, 0x90AF, 0x90B0, 0x90B3,
        0x90B4, 0x90B5, 0x90B6, 0x90B8, 0x90B9, 0x90BA, 0x90BB, 0x90BC,
        0x90BD, 0x90C1, 0x90C2, 0x90C3, 0x90C4, 0x90C5, 0x90C6, 0x90C7,
        0x90C8, 0x90C9, 0x90CA, 0x90CB, 0x90CC, 0x90CD, 0x90CE, 0x90CF,
        0x90D0, 0x90D1, 0x90D3, 0x90D4, 0x90D5, 0x90D6, 0x90D7, 0x90D8,
        0x90D9, 0x90DA, 0x90DB, 0x90DC, 0x90DD, 0x90E3, 0x90E6, 0x90E7,
        0x90E8, 0x90EA, 0x90ED, 0x90EE, 0x90EF, 0x90F0, 0x90F4, 0x90F8,
        0x90F9, 0x90FA, 0x90FB, 0x90FC, 0x9143, 0x9144, 0x9146, 0x9147,
        0x9148, 0x914A, 0x914B, 0x914C, 0x914D, 0x914E, 0x914F, 0x9150,
        0x9154, 0x9158, 0x9159, 0x915A, 0x915B, 0x915C, 0x915D, 0x9163,
        0x9164, 0x9166, 0x9167, 0x9168, 0x916A, 0x916B, 0x916C, 0x916D,
        0x916E, 0x916F, 0x9170, 0x9174, 0x9175, 0x9178, 0x9179, 0x917B,
        0x917C, 0x917D, 0x9182, 0x9183, 0x9184, 0x9186, 0x9187, 0x9188,
        0x9189, 0x918A, 0x918B, 0x918C, 0x918D, 0x918E, 0x918F, 0x9190,
        0x9191, 0x9193, 0x9194, 0x9195, 0x9196, 0x9197, 0x9198, 0x9199,
        0x919A, 0x919B, 0x919C, 0x919D, 0x91A3, 0x91A4, 0x91A6, 0x91A7,
        0x91A8, 0x91AA, 0x91AC, 0x91AD, 0x91AE, 0x91AF, 0x91B0, 0x91B4,
        0x91B6, 0x91B8, 0x91B9, 0x91BA, 0x91BB, 0x91C2, 0x91C3, 0x91C4,
        0x91C6, 0x91C7, 0x91C8, 0x91CA, 0x91CB, 0x91CC, 0x91CD, 0x91CE,
        0x91CF, 0x91D0, 0x91D1, 0x91D3, 0x91D4, 0x91D5, 0x91D7, 0x91D8,
        0x91D9, 0x91DA, 0x91DB, 0x91DC, 0x91DD, 0x91E1, 0x91E2, 0x91E3,
        0x91E4, 0x91E5, 0x91E6, 0x91E7, 0x91E8, 0x91E9, 0x91EA, 0x91EB,
        0x91EC, 0x91ED, 0x91EE, 0x91EF, 0x91F0, 0x91F1, 0x91F3, 0x91F4,
        0x91F5, 0x91F6, 0x91F7, 0x91F8, 0x91F9, 0x91FA, 0x91FB, 0x91FC,
        0x91FD, 0x9242, 0x9243, 0x9244, 0x9246, 0x9247, 0x9248, 0x924A,
        0x924B, 0x924C, 0x924D, 0x924E, 0x924F, 0x9250, 0x9254, 0x9256,
        0x9257, 0x9258, 0x9259, 0x925A, 0x925B, 0x925C, 0x925D, 0x9263,
        0x9264, 0x9266, 0x9267, 0x9268, 0x926A, 0x926B, 0x926C, 0x926D,
        0x926E, 0x926F, 0x9270, 0x9271, 0x9274, 0x9276, 0x9278, 0x9279,
        0x927A, 0x927B, 0x927C, 0x927D, 0x9283, 0x9284, 0x9286, 0x9287,
        0x928A, 0x928B, 0x928C, 0x928D, 0x928E, 0x928F, 0x9290, 0x9294,
        0x9296, 0x9298, 0x9299, 0x929A, 0x929B, 0x929C, 0x929D, 0x92A2,
        0x92A3, 0x92A4, 0x92A5, 0x92A6, 0x92A7, 0x92A8, 0x92A9, 0x92AA,
        0x92AB, 0x92AC, 0x92AD, 0x92AE, 0x92AF, 0x92B0, 0x92B1, 0x92B3,
        0x92B4, 0x92B5, 0x92B7, 0x92B8, 0x92B9, 0x92BA, 0x92BB, 0x92BC,
        0x92BD, 0x92C2, 0x92C3, 0x92C4, 0x92C5, 0x92C6, 0x92C7, 0x92C8,
        0x92C9, 0x92CA, 0x92CB, 0x92CC, 0x92CD, 0x92CE, 0x92CF, 0x92D0,
        0x92D1, 0x92D3, 0x92D4, 0x92D5, 0x92D6, 0x92D7, 0x92D8, 0x92D9,
        0x92DA, 0x92DB, 0x92DC, 0x92DD, 0x92E2, 0x92E3, 0x92E4, 0x92E6,
        0x92E7, 0x92E8, 0x92EA, 0x92EB, 0x92EC, 0x92ED, 0x92EE, 0x92EF,
        0x92F0, 0x92F4, 0x92F5, 0x92F6, 0x92F7, 0x92F8, 0x92F9, 0x92FA,
        0x92FB, 0x92FC, 0x92FD, 0x9343, 0x9344, 0x9345, 0x9346, 0x9347,
        0x9348, 0x934A, 0x934B, 0x934C, 0x934D, 0x934E, 0x934F, 0x9350,
        0x9354, 0x9355, 0x9356, 0x9358, 0x9359, 0x935A, 0x935B, 0x935C,
        0x935D, 0x9363, 0x9364, 0x9366, 0x9367, 0x9368, 0x936C, 0x936D,
        0x936E, 0x936F, 0x9370, 0x9374, 0x9376, 0x9379, 0x937A, 0x937B,
        0x937D, 0x9382, 0x9383, 0x9384, 0x9386, 0x9387, 0x9388, 0x938A,
        0x938B, 0x938C, 0x938D, 0x938E, 0x938F, 0x9390, 0x9391, 0x9393,
        0x9394, 0x9395, 0x9396, 0x9397, 0x9398, 0x9399, 0x939A, 0x939B,
        0x939C, 0x939D, 0x93A3, 0x93A4, 0x93A6, 0x93A7, 0x93A8, 0x93AA,
        0x93AB, 0x93AC, 0x93AD, 0x93AE, 0x93B0, 0x93B4, 0x93B6, 0x93B8,
        0x93B9, 0x93BA, 0x93BB, 0x93BD, 0x9464, 0x9466, 0x9467, 0x946D,
        0x946E, 0x946F, 0x9474, 0x947A, 0x947B, 0x947C, 0x9483, 0x9484,
        0x9486, 0x9487, 0x9488, 0x948A, 0x948B, 0x948C, 0x948D, 0x948E,
        0x948F, 0x9490, 0x9494, 0x9498, 0x9499, 0x949A, 0x949B, 0x949C,
        0x949D, 0x94A2, 0x94A3, 0x94A4, 0x94A5, 0x94A6, 0x94A7, 0x94A8,
        0x94A9, 0x94AA, 0x94AB, 0x94AC, 0x94AD, 0x94AE, 0x94AF, 0x94B0,
        0x94B1, 0x94B3, 0x94B4, 0x94B5, 0x94B6, 0x94B7, 0x94B8, 0x94B9,
        0x94BA, 0x94BB, 0x94BC, 0x94BD, 0x94C1, 0x94C2, 0x94C3, 0x94C4,
        0x94C5, 0x94C6, 0x94C7, 0x94C8, 0x94C9, 0x94CA, 0x94CB, 0x94CC,
        0x94CD, 0x94CE, 0x94CF, 0x94D0, 0x94D1, 0x94D3, 0x94D4, 0x94D5,
        0x94D6, 0x94D7, 0x94D8, 0x94D9, 0x94DA, 0x94DB, 0x94DC, 0x94DD,
        0x94E4, 0x94E6, 0x94E7, 0x94EA, 0x94ED, 0x94EE, 0x94EF, 0x94F0,
        0x94F4, 0x94F6, 0x94F8, 0x94FA, 0x94FB, 0x94FD, 0x9543, 0x9544,
        0x9546, 0x9547, 0x9548, 0x954A, 0x954B, 0x954C, 0x954D, 0x954E,
        0x954F, 0x9550, 0x9554, 0x9558, 0x9559, 0x955A, 0x955B, 0x955C,
        0x955D, 0x9562, 0x9563, 0x9564, 0x9566, 0x9567, 0x9568, 0x956A,
        0x956B, 0x956C, 0x956D, 0x956E, 0x956F, 0x9570, 0x9571, 0x9573,
        0x9574, 0x9575, 0x9578, 0x9579, 0x957A, 0x957B, 0x957C, 0x957D,
        0x9582, 0x9583, 0x9584, 0x9586, 0x9587, 0x9588, 0x9589, 0x958A,
        0x958B, 0x958C, 0x958D, 0x958E, 0x958F, 0x9590, 0x9591, 0x9593,
        0x9594, 0x9595, 0x9596, 0x9597, 0x9598, 0x9599, 0x959A, 0x959B,
        0x959C, 0x959D, 0x95A3, 0x95A4, 0x95A6, 0x95A7, 0x95AA, 0x95AC,
        0x95AE, 0x95AF, 0x95B0, 0x95B4, 0x95B6, 0x95B8, 0x95BA, 0x95BC,
        0x95BD, 0x95C2, 0x95C3, 0x95C4, 0x95C6, 0x95C7, 0x95C8, 0x95CA,
        0x95CB, 0x95CC, 0x95CD, 0x95CE, 0x95CF, 0x95D0, 0x95D1, 0x95D3,
        0x95D4, 0x95D5, 0x95D6, 0x95D7, 0x95D8, 0x95D9, 0x95DA, 0x95DB,
        0x95DC, 0x95DD, 0x95E2, 0x95E3, 0x95E4, 0x95E5, 0x95E6, 0x95E7,
        0x95E8, 0x95E9, 0x95EA, 0x95EB, 0x95EC, 0x95ED, 0x95EE, 0x95EF,
        0x95F0, 0x95F1, 0x95F3, 0x95F4, 0x95F5, 0x95F7, 0x95F8, 0x95F9,
        0x95FA, 0x95FB, 0x95FC, 0x95FD, 0x9642, 0x9643, 0x9644, 0x9646,
        0x9647, 0x9648, 0x964A, 0x964B, 0x964C, 0x964D, 0x964E, 0x964F,
        0x9650, 0x9654, 0x9656, 0x9657, 0x9658, 0x9659, 0x965A, 0x965B,
        0x965C, 0x965D, 0x9662, 0x9663, 0x9664, 0x9665, 0x9666, 0x9667,
        0x9668, 0x9669, 0x966A, 0x966B, 0x966C, 0x966D, 0x966E, 0x966F,
        0x9670, 0x9671, 0x9673, 0x9674, 0x9675, 0x9676, 0x9677, 0x9678,
        0x9679, 0x967A, 0x967B, 0x967C, 0x967D, 0x9683, 0x9684, 0x9686,
        0x9687, 0x9688, 0x968A, 0x968B, 0x968C, 0x968D, 0x968E, 0x968F,
        0x9690, 0x9694, 0x9696, 0x9698, 0x9699, 0x969A, 0x969B, 0x969C,
        0x969D, 0x96A2, 0x96A3, 0x96A4, 0x96A5, 0x96A6, 0x96A7, 0x96A8,
        0x96A9, 0x96AA, 0x96AB, 0x96AC, 0x96AD, 0x96AE, 0x96AF, 0x96B0,
        0x96B1, 0x96B3, 0x96B4, 0x96B5, 0x96B7, 0x96B8, 0x96B9, 0x96BA,
        0x96BB, 0x96BC, 0x96BD, 0x96C2, 0x96C3, 0x96C4, 0x96C5, 0x96C6,
        0x96C7, 0x96C8, 0x96C9, 0x96CA, 0x96CB, 0x96CC, 0x96CD, 0x96CE,
        0x96CF, 0x96D0, 0x96D1, 0x96D3, 0x96D4, 0x96D5, 0x96D6, 0x96D8,
        0x96D9, 0x96DA, 0x96DB, 0x96DC, 0x96DD, 0x96E2, 0x96E3, 0x96E4,
        0x96E6, 0x96E7, 0x96E8, 0x96EA, 0x96EB, 0x96EC, 0x96ED, 0x96EE,
        0x96EF, 0x96F0, 0x96F1, 0x96F4, 0x96F6, 0x96F8, 0x96F9, 0x96FA,
        0x96FB, 0x96FC, 0x96FD, 0x9742, 0x9743, 0x9744, 0x9746, 0x9747,
        0x9748, 0x974A, 0x974B, 0x974C, 0x974D, 0x974E, 0x974F, 0x9750,
        0x9753, 0x9754, 0x9755, 0x9756, 0x9758, 0x9759, 0x975A, 0x975B,
        0x975C, 0x975D, 0x9763, 0x9764, 0x9766, 0x9767, 0x976A, 0x976C,
        0x976D, 0x976E, 0x976F, 0x9770, 0x9774, 0x9776, 0x9778, 0x9779,
        0x977A, 0x977B, 0x977C, 0x977D, 0x9782, 0x9783, 0x9784, 0x9785,
        0x9786, 0x9787, 0x9788, 0x9789, 0x978A, 0x978B, 0x978C, 0x978D,
        0x978E, 0x978F, 0x9790, 0x9791, 0x9793, 0x9794, 0x9795, 0x9796,
        0x9797, 0x9798, 0x9799, 0x979A, 0x979B, 0x979C, 0x979D, 0x97A3,
        0x97A4, 0x97A6, 0x97A7, 0x97AA, 0x97AB, 0x97AC, 0x97AD, 0x97AE,
        0x97AF, 0x97B0, 0x97B4, 0x97B9, 0x97BA, 0x97BB, 0x97BC, 0x97BD,
        0x9863, 0x9864, 0x9866, 0x9867, 0x9868, 0x986A, 0x986B, 0x986C,
        0x986D, 0x986E, 0x986F, 0x9870, 0x9874, 0x9878, 0x9879, 0x987A,
        0x987B, 0x987C, 0x9883, 0x9884, 0x9886, 0x9887, 0x9888, 0x988A,
        0x988B, 0x988C, 0x988D, 0x988E, 0x988F, 0x9890, 0x9894, 0x9898,
        0x9899, 0x989A, 0x989B, 0x989C, 0x989D, 0x98A1, 0x98A2, 0x98A3,
        0x98A4, 0x98A5, 0x98A6, 0x98A7, 0x98A8, 0x98A9, 0x98AA, 0x98AB,
        0x98AC, 0x98AD, 0x98AE, 0x98AF, 0x98B0, 0x98B1, 0x98B3, 0x98B4,
        0x98B5, 0x98B6, 0x98B7, 0x98B8, 0x98B9, 0x98BA, 0x98BB, 0x98BC,
        0x98BD, 0x98C1, 0x98C2, 0x98C3, 0x98C4, 0x98C5, 0x98C6, 0x98C7,
        0x98C8, 0x98C9, 0x98CA, 0x98CB, 0x98CC, 0x98CD, 0x98CE, 0x98CF,
        0x98D0, 0x98D1, 0x98D3, 0x98D4, 0x98D5, 0x98D6, 0x98D7, 0x98D8,
        0x98D9, 0x98DA, 0x98DB, 0x98DC, 0x98DD, 0x98E3, 0x98E4, 0x98E6,
        0x98E7, 0x98E8, 0x98EA, 0x98ED, 0x98EE, 0x98EF, 0x98F0, 0x98F4,
        0x98F8, 0x98F9, 0x98FA, 0x98FB, 0x98FC, 0x9943, 0x9944, 0x9946,
        0x9947, 0x9948, 0x994A, 0x994B, 0x994C, 0x994D, 0x994E, 0x994F,
        0x9950, 0x9954, 0x9958, 0x9959, 0x995A, 0x995B, 0x995C, 0x995D,
        0x9962, 0x9963, 0x9964, 0x9965, 0x9966, 0x9967, 0x9968, 0x9969,
        0x996A, 0x996B, 0x996C, 0x996D, 0x996E, 0x996F, 0x9970, 0x9971,
        0x9973, 0x9974, 0x9975, 0x9977, 0x9978, 0x9979, 0x997A, 0x997B,
        0x997C, 0x997D, 0x9981, 0x9982, 0x9983, 0x9984, 0x9985, 0x9986,
        0x9987, 0x9988, 0x9989, 0x998A, 0x998B, 0x998C, 0x998D, 0x998E,
        0x998F, 0x9990, 0x9991, 0x9993, 0x9994, 0x9995, 0x9996, 0x9997,
        0x9998, 0x9999, 0x999A, 0x999B, 0x999C, 0x999D, 0x99A3, 0x99A4,
        0x99A6, 0x99A7, 0x99A8, 0x99AA, 0x99AB, 0x99AC, 0x99AD, 0x99AE,
        0x99AF, 0x99B0, 0x99B1, 0x99B3, 0x99B4, 0x99B5, 0x99B6, 0x99B8,
        0x99B9, 0x99BA, 0x99BB, 0x99BC, 0x99BD, 0x99C2, 0x99C3, 0x99C4,
        0x99C5, 0x99C6, 0x99C7, 0x99C8, 0x99CA, 0x99CB, 0x99CC, 0x99CD,
        0x99CE, 0x99CF, 0x99D0, 0x99D1, 0x99D3, 0x99D4, 0x99D5, 0x99D6,
        0x99D7, 0x99D8, 0x99D9, 0x99DA, 0x99DB, 0x99DC, 0x99DD, 0x99E2,
        0x99E3, 0x99E4, 0x99E5, 0x99E6, 0x99E7, 0x99E8, 0x99E9, 0x99EA,
        0x99EB, 0x99EC, 0x99ED, 0x99EE, 0x99EF, 0x99F0, 0x99F1, 0x99F3,
        0x99F4, 0x99F5, 0x99F6, 0x99F7, 0x99F8, 0x99F9, 0x99FA, 0x99FB,
        0x99FC, 0x99FD, 0x9A42, 0x9A43, 0x9A44, 0x9A46, 0x9A47, 0x9A48,
        0x9A49, 0x9A4A, 0x9A4B, 0x9A4C, 0x9A4D, 0x9A4E, 0x9A4F, 0x9A50,
        0x9A51, 0x9A53, 0x9A54, 0x9A55, 0x9A56, 0x9A57, 0x9A58, 0x9A59,
        0x9A5A, 0x9A5B, 0x9A5C, 0x9A5D, 0x9A61, 0x9A62, 0x9A63, 0x9A64,
        0x9A65, 0x9A66, 0x9A67, 0x9A68, 0x9A69, 0x9A6A, 0x9A6B, 0x9A6C,
        0x9A6D, 0x9A6E, 0x9A6F, 0x9A70, 0x9A71, 0x9A73, 0x9A74, 0x9A75,
        0x9A76, 0x9A77, 0x9A78, 0x9A79, 0x9A7A, 0x9A7B, 0x9A7C, 0x9A7D,
        0x9A83, 0x9A84, 0x9A86, 0x9A87, 0x9A88, 0x9A8A, 0x9A8B, 0x9A8C,
        0x9A8D, 0x9A8E, 0x9A8F, 0x9A93, 0x9A94, 0x9A95, 0x9A96, 0x9A98,
        0x9A99, 0x9A9A, 0x9A9B, 0x9A9C, 0x9A9D, 0x9AA1, 0x9AA2, 0x9AA3,
        0x9AA4, 0x9AA5, 0x9AA6, 0x9AA7, 0x9AA8, 0x9AA9, 0x9AAA, 0x9AAB,
        0x9AAC, 0x9AAD, 0x9AAE, 0x9AAF, 0x9AB0, 0x9AB1, 0x9AB3, 0x9AB4,
        0x9AB5, 0x9AB6, 0x9AB7, 0x9AB8, 0x9AB9, 0x9ABA, 0x9ABB, 0x9ABC,
        0x9ABD, 0x9AC2, 0x9AC3, 0x9AC4, 0x9AC5, 0x9AC6, 0x9AC7, 0x9AC8,
        0x9AC9, 0x9ACA, 0x9ACB, 0x9ACC, 0x9ACD, 0x9ACE, 0x9ACF, 0x9AD0,
        0x9AD1, 0x9AD3, 0x9AD4, 0x9AD5, 0x9AD6, 0x9AD7, 0x9AD8, 0x9AD9,
        0x9ADA, 0x9ADB, 0x9ADC, 0x9ADD, 0x9AE2, 0x9AE3, 0x9AE4, 0x9AE6,
        0x9AE7, 0x9AE8, 0x9AEA, 0x9AEB, 0x9AEC, 0x9AED, 0x9AEE, 0x9AEF,
        0x9AF0, 0x9AF4, 0x9AF5, 0x9AF6, 0x9AF8, 0x9AF9, 0x9AFA, 0x9AFB,
        0x9AFC, 0x9AFD, 0x9B41, 0x9B42, 0x9B43, 0x9B44, 0x9B45, 0x9B46,
        0x9B47, 0x9B48, 0x9B49, 0x9B4A, 0x9B4B, 0x9B4C, 0x9B4D, 0x9B4E,
        0x9B4F, 0x9B50, 0x9B51, 0x9B53, 0x9B54, 0x9B55, 0x9B56, 0x9B57,
        0x9B58, 0x9B59, 0x9B5A, 0x9B5B, 0x9B5C, 0x9B5D, 0x9B63, 0x9B64,
        0x9B66, 0x9B67, 0x9B6A, 0x9B6B, 0x9B6C, 0x9B6D, 0x9B6E, 0x9B6F,
        0x9B70, 0x9B74, 0x9B76, 0x9B77, 0x9B78, 0x9B79, 0x9B7A, 0x9B7B,
        0x9B7C, 0x9B7D, 0x9B82, 0x9B83, 0x9B84, 0x9B86, 0x9B87, 0x9B88,
        0x9B8A, 0x9B8B, 0x9B8C, 0x9B8D, 0x9B8E, 0x9B8F, 0x9B90, 0x9B94,
        0x9B95, 0x9B96, 0x9B97, 0x9B98, 0x9B99, 0x9B9A, 0x9B9B, 0x9B9C,
        0x9B9D, 0x9BA2, 0x9BA3, 0x9BA4, 0x9BA6, 0x9BA7, 0x9BA8, 0x9BAA,
        0x9BAB, 0x9BAC, 0x9BAD, 0x9BAE, 0x9BAF, 0x9BB0, 0x9BB4, 0x9BB6,
        0x9BB8, 0x9BB9, 0x9BBA, 0x9BBB, 0x9BBC, 0x9BBD, 0x9C63, 0x9C64,
        0x9C66, 0x9C67, 0x9C68, 0x9C6A, 0x9C6B, 0x9C6C, 0x9C6D, 0x9C6E,
        0x9C6F, 0x9C70, 0x9C74, 0x9C79, 0x9C7A, 0x9C7B, 0x9C83, 0x9C84,
        0x9C86, 0x9C87, 0x9C88, 0x9C8A, 0x9C8B, 0x9C8C, 0x9C8D, 0x9C8E,
        0x9C8F, 0x9C90, 0x9C94, 0x9C98, 0x9C99, 0x9C9A, 0x9C9B, 0x9C9C,
        0x9C9D, 0x9CA3, 0x9CA4, 0x9CA6, 0x9CA7, 0x9CA8, 0x9CA9, 0x9CAA,
        0x9CAB, 0x9CAC, 0x9CAD, 0x9CAE, 0x9CAF, 0x9CB0, 0x9CB1, 0x9CB3,
        0x9CB4, 0x9CB6, 0x9CB8, 0x9CB9, 0x9CBA, 0x9CBB, 0x9CBC, 0x9CBD,
        0x9CC1, 0x9CC2, 0x9CC3, 0x9CC4, 0x9CC5, 0x9CC6, 0x9CC7, 0x9CC8,
        0x9CC9, 0x9CCA, 0x9CCB, 0x9CCC, 0x9CCD, 0x9CCE, 0x9CCF, 0x9CD0,
        0x9CD1, 0x9CD3, 0x9CD4, 0x9CD5, 0x9CD6, 0x9CD7, 0x9CD8, 0x9CD9,
        0x9CDA, 0x9CDB, 0x9CDC, 0x9CDD, 0x9CE3, 0x9CE4, 0x9CE6, 0x9CE7,
        0x9CE8, 0x9CEA, 0x9CEB, 0x9CEC, 0x9CED, 0x9CEE, 0x9CEF, 0x9CF0,
        0x9CF4, 0x9CF8, 0x9CF9, 0x9CFA, 0x9CFB, 0x9CFC, 0x9D43, 0x9D44,
        0x9D46, 0x9D47, 0x9D48, 0x9D4A, 0x9D4B, 0x9D4C, 0x9D4D, 0x9D4E,
        0x9D4F, 0x9D50, 0x9D54, 0x9D56, 0x9D58, 0x9D59, 0x9D5A, 0x9D5B,
        0x9D5C, 0x9D5D, 0x9D63, 0x9D64, 0x9D66, 0x9D67, 0x9D68, 0x9D6A,
        0x9D6B, 0x9D6C, 0x9D6D, 0x9D6E, 0x9D6F, 0x9D70, 0x9D74, 0x9D78,
        0x9D79, 0x9D7A, 0x9D7B, 0x9D7C, 0x9D7D, 0x9D82, 0x9D83, 0x9D84,
        0x9D86, 0x9D87, 0x9D88, 0x9D89, 0x9D8A, 0x9D8B, 0x9D8C, 0x9D8D,
        0x9D8E, 0x9D8F, 0x9D90, 0x9D91, 0x9D94, 0x9D96, 0x9D97, 0x9D98,
        0x9D99, 0x9D9A, 0x9D9B, 0x9D9C, 0x9D9D, 0x9DA3, 0x9DA4, 0x9DA6,
        0x9DA7, 0x9DA8, 0x9DAA, 0x9DAB, 0x9DAC, 0x9DAD, 0x9DAE, 0x9DAF,
        0x9DB0, 0x9DB4, 0x9DB6, 0x9DB8, 0x9DB9, 0x9DBA, 0x9DBB, 0x9DBC,
        0x9DBD, 0x9DC2, 0x9DC3, 0x9DC4, 0x9DC6, 0x9DC7, 0x9DC8, 0x9DC9,
        0x9DCA, 0x9DCB, 0x9DCC, 0x9DCD, 0x9DCE, 0x9DCF, 0x9DD0, 0x9DD1,
        0x9DD3, 0x9DD4, 0x9DD5, 0x9DD6, 0x9DD8, 0x9DD9, 0x9DDA, 0x9DDB,
        0x9DDC, 0x9DDD, 0x9DE1, 0x9DE2, 0x9DE3, 0x9DE4, 0x9DE5, 0x9DE6,
        0x9DE7, 0x9DE8, 0x9DE9, 0x9DEA, 0x9DEB, 0x9DEC, 0x9DED, 0x9DEE,
        0x9DEF, 0x9DF0, 0x9DF1, 0x9DF3, 0x9DF4, 0x9DF5, 0x9DF7, 0x9DF8,
        0x9DF9, 0x9DFA, 0x9DFB, 0x9DFC, 0x9DFD, 0x9E42, 0x9E43, 0x9E44,
        0x9E46, 0x9E47, 0x9E48, 0x9E4A, 0x9E4B, 0x9E4C, 0x9E4D, 0x9E4E,
        0x9E4F, 0x9E50, 0x9E54, 0x9E56, 0x9E58, 0x9E59, 0x9E5A, 0x9E5B,
        0x9E5C, 0x9E5D, 0x9E62, 0x9E63, 0x9E64, 0x9E66, 0x9E67, 0x9E68,
        0x9E6A, 0x9E6B, 0x9E6C, 0x9E6D, 0x9E6E, 0x9E6F, 0x9E70, 0x9E71,
        0x9E74, 0x9E76, 0x9E78, 0x9E79, 0x9E7A, 0x9E7B, 0x9E7C, 0x9E7D,
        0x9E83, 0x9E84, 0x9E86, 0x9E87, 0x9E88, 0x9E8A, 0x9E8B, 0x9E8C,
        0x9E8D, 0x9E8E, 0x9E8F, 0x9E90, 0x9E94, 0x9E96, 0x9E98, 0x9E99,
        0x9E9A, 0x9E9B, 0x9E9C, 0x9E9D, 0x9EA2, 0x9EA3, 0x9EA4, 0x9EA5,
        0x9EA6, 0x9EA7, 0x9EA8, 0x9EA9, 0x9EAA, 0x9EAB, 0x9EAC, 0x9EAD,
        0x9EAE, 0x9EAF, 0x9EB0, 0x9EB1, 0x9EB3, 0x9EB4, 0x9EB5, 0x9EB7,
        0x9EB8, 0x9EB9, 0x9EBA, 0x9EBB, 0x9EBC, 0x9EBD, 0x9EC2, 0x9EC3,
        0x9EC4, 0x9EC5, 0x9EC6, 0x9EC7, 0x9EC8, 0x9EC9, 0x9ECA, 0x9ECB,
        0x9ECC, 0x9ECD, 0x9ECE, 0x9ECF, 0x9ED0, 0x9ED1, 0x9ED3, 0x9ED4,
        0x9ED5, 0x9ED6, 0x9ED7, 0x9ED8, 0x9ED9, 0x9EDA, 0x9EDB, 0x9EDC,
        0x9EDD, 0x9EE3, 0x9EE4, 0x9EE6, 0x9EE7, 0x9EE8, 0x9EEA, 0x9EEB,
        0x9EEC, 0x9EED, 0x9EEE, 0x9EEF, 0x9EF0, 0x9EF3, 0x9EF4, 0x9EF6,
        0x9EF8, 0x9EF9, 0x9EFA, 0x9EFB, 0x9EFC, 0x9EFD, 0x9F43, 0x9F44,
        0x9F46, 0x9F47, 0x9F48, 0x9F4A, 0x9F4B, 0x9F4C, 0x9F4D, 0x9F4E,
        0x9F4F, 0x9F50, 0x9F54, 0x9F56, 0x9F58, 0x9F59, 0x9F5A, 0x9F5B,
        0x9F5C, 0x9F5D, 0x9F63, 0x9F64, 0x9F66, 0x9F67, 0x9F68, 0x9F6A,
        0x9F6B, 0x9F6C, 0x9F6D, 0x9F6E, 0x9F6F, 0x9F70, 0x9F74, 0x9F76,
        0x9F79, 0x9F7A, 0x9F7D, 0x9F81, 0x9F82, 0x9F83, 0x9F84, 0x9F85,
        0x9F86, 0x9F87, 0x9F88, 0x9F89, 0x9F8A, 0x9F8B, 0x9F8C, 0x9F8D,
        0x9F8E, 0x9F8F, 0x9F90, 0x9F91, 0x9F93, 0x9F94, 0x9F95, 0x9F96,
        0x9F97, 0x9F98, 0x9F99, 0x9F9A, 0x9F9B, 0x9F9C, 0x9F9D, 0x9FA3,
        0x9FA4, 0x9FA6, 0x9FA7, 0x9FA8, 0x9FAA, 0x9FAB, 0x9FAC, 0x9FAD,
        0x9FAE, 0x9FAF, 0x9FB0, 0x9FB4, 0x9FB6, 0x9FB8, 0x9FB9, 0x9FBA,
        0x9FBB, 0x9FBC, 0x9FBD, 0xA063, 0xA064, 0xA066, 0xA06C, 0xA06D,
        0xA06E, 0xA06F, 0xA070, 0xA074, 0xA076, 0xA079, 0xA07A, 0xA07C,
        0xA083, 0xA084, 0xA086, 0xA087, 0xA088, 0xA08A, 0xA08B, 0xA08C,
        0xA08D, 0xA08E, 0xA08F, 0xA090, 0xA094, 0xA099, 0xA09A, 0xA09B,
        0xA09C, 0xA09D, 0xA0A3, 0xA0A4, 0xA0A5, 0xA0A6, 0xA0A7, 0xA0A8,
        0xA0AA, 0xA0AB, 0xA0AC, 0xA0AD, 0xA0AE, 0xA0AF, 0xA0B0, 0xA0B1,
        0xA0B3, 0xA0B4, 0xA0B5, 0xA0B6, 0xA0B8, 0xA0B9, 0xA0BA, 0xA0BB,
        0xA0BC, 0xA0BD, 0xA0C1, 0xA0C2, 0xA0C3, 0xA0C4, 0xA0C5, 0xA0C6,
        0xA0C7, 0xA0C8, 0xA0C9, 0xA0CA, 0xA0CB, 0xA0CC, 0xA0CD, 0xA0CE,
        0xA0CF, 0xA0D0, 0xA0D1, 0xA0D3, 0xA0D4, 0xA0D5, 0xA0D6, 0xA0D7,
        0xA0D8, 0xA0D9, 0xA0DA, 0xA0DB, 0xA0DC, 0xA0DD, 0xA0E3, 0xA0E4,
        0xA0E6, 0xA0E7, 0xA0E8, 0xA0EA, 0xA0EC, 0xA0ED, 0xA0EE, 0xA0EF,
        0xA0F0, 0xA0F4, 0xA0F6, 0xA0F9, 0xA0FA, 0xA0FB, 0xA0FC, 0xA143,
        0xA144, 0xA146, 0xA147, 0xA148, 0xA14A, 0xA14B, 0xA14C, 0xA14D,
        0xA14E, 0xA14F, 0xA150, 0xA154, 0xA158, 0xA159, 0xA15A, 0xA15B,
        0xA15C, 0xA15D, 0xA163, 0xA164, 0xA166, 0xA167, 0xA168, 0xA16A,
        0xA16B, 0xA16C, 0xA16D, 0xA16E, 0xA16F, 0xA170, 0xA171, 0xA173,
        0xA174, 0xA178, 0xA17A, 0xA17B, 0xA17C, 0xA17D, 0xA182, 0xA183,
        0xA184, 0xA185, 0xA186, 0xA187, 0xA188, 0xA189, 0xA18A, 0xA18B,
        0xA18C, 0xA18D, 0xA18E, 0xA18F, 0xA190, 0xA191, 0xA193, 0xA194,
        0xA195, 0xA196, 0xA197, 0xA198, 0xA199, 0xA19A, 0xA19B, 0xA19C,
        0xA19D, 0xA1A3, 0xA1A6, 0xA1A7, 0xA1A8, 0xA1AA, 0xA1AC, 0xA1AD,
        0xA1AE, 0xA1AF, 0xA1B0, 0xA1B4, 0xA1B6, 0xA1B8, 0xA1B9, 0xA1BA,
        0xA1BB, 0xA1BC, 0xA1BD, 0xA1C2, 0xA1C3, 0xA1C4, 0xA1C6, 0xA1C7,
        0xA1C8, 0xA1C9, 0xA1CA, 0xA1CB, 0xA1CC, 0xA1CD, 0xA1CE, 0xA1CF,
        0xA1D0, 0xA1D1, 0xA1D3, 0xA1D4, 0xA1D5, 0xA1D8, 0xA1D9, 0xA1DA,
        0xA1DB, 0xA1DC, 0xA1DD, 0xA1E1, 0xA1E2, 0xA1E3, 0xA1E4, 0xA1E5,
        0xA1E6, 0xA1E7, 0xA1E8, 0xA1E9, 0xA1EA, 0xA1EB, 0xA1EC, 0xA1ED,
        0xA1EE, 0xA1EF, 0xA1F0, 0xA1F1, 0xA1F3, 0xA1F4, 0xA1F5, 0xA1F6,
        0xA1F7, 0xA1F8, 0xA1F9, 0xA1FA, 0xA1FB, 0xA1FC, 0xA1FD, 0xA242,
        0xA243, 0xA244, 0xA246, 0xA247, 0xA248, 0xA24A, 0xA24B, 0xA24C,
        0xA24D, 0xA24E, 0xA24F, 0xA250, 0xA251, 0xA254, 0xA256, 0xA258,
        0xA259, 0xA25A, 0xA25B, 0xA25C, 0xA25D, 0xA262, 0xA263, 0xA264,
        0xA266, 0xA267, 0xA268, 0xA26A, 0xA26B, 0xA26C, 0xA26D, 0xA26E,
        0xA26F, 0xA270, 0xA271, 0xA274, 0xA276, 0xA277, 0xA278, 0xA279,
        0xA27A, 0xA27B, 0xA27C, 0xA27D, 0xA284, 0xA286, 0xA287, 0xA28C,
        0xA28D, 0xA28E, 0xA28F, 0xA290, 0xA294, 0xA296, 0xA298, 0xA299,
        0xA29A, 0xA29C, 0xA2A2, 0xA2A3, 0xA2A4, 0xA2A6, 0xA2A7, 0xA2A8,
        0xA2AA, 0xA2AB, 0xA2AC, 0xA2AD, 0xA2AE, 0xA2AF, 0xA2B0, 0xA2B1,
        0xA2B4, 0xA2B6, 0xA2B7, 0xA2B8, 0xA2B9, 0xA2BA, 0xA2BB, 0xA2BC,
        0xA2BD, 0xA2C2, 0xA2C3, 0xA2C4, 0xA2C5, 0xA2C6, 0xA2C7, 0xA2C8,
        0xA2C9, 0xA2CA, 0xA2CB, 0xA2CC, 0xA2CD, 0xA2CE, 0xA2CF, 0xA2D0,
        0xA2D1, 0xA2D3, 0xA2D4, 0xA2D5, 0xA2D6, 0xA2D7, 0xA2D8, 0xA2D9,
        0xA2DA, 0xA2DB, 0xA2DC, 0xA2DD, 0xA2E2, 0xA2E3, 0xA2E4, 0xA2E6,
        0xA2E7, 0xA2E8, 0xA2EA, 0xA2EB, 0xA2EC, 0xA2ED, 0xA2EE, 0xA2EF,
        0xA2F0, 0xA2F1, 0xA2F3, 0xA2F4, 0xA2F5, 0xA2F6, 0xA2F7, 0xA2F8,
        0xA2F9, 0xA2FA, 0xA2FB, 0xA2FC, 0xA2FD, 0xA342, 0xA343, 0xA344,
        0xA346, 0xA347, 0xA348, 0xA34A, 0xA34B, 0xA34C, 0xA34D, 0xA34E,
        0xA34F, 0xA350, 0xA353, 0xA354, 0xA356, 0xA357, 0xA358, 0xA359,
        0xA35A, 0xA35B, 0xA35C, 0xA35D, 0xA362, 0xA363, 0xA364, 0xA366,
        0xA367, 0xA368, 0xA36A, 0xA36B, 0xA36C, 0xA36D, 0xA36E, 0xA36F,
        0xA370, 0xA373, 0xA374, 0xA376, 0xA377, 0xA378, 0xA379, 0xA37A,
        0xA37B, 0xA37C, 0xA37D, 0xA381, 0xA382, 0xA383, 0xA384, 0xA385,
        0xA386, 0xA387, 0xA388, 0xA389, 0xA38A, 0xA38B, 0xA38C, 0xA38D,
        0xA38E, 0xA38F, 0xA390, 0xA391, 0xA393, 0xA394, 0xA395, 0xA396,
        0xA397, 0xA398, 0xA399, 0xA39A, 0xA39B, 0xA39C, 0xA39D, 0xA3A3,
        0xA3A4, 0xA3A6, 0xA3A7, 0xA3AA, 0xA3AC, 0xA3AD, 0xA3AE, 0xA3AF,
        0xA3B0, 0xA3B4, 0xA3B8, 0xA3BA, 0xA3BC, 0xA3BD, 0xA466, 0xA467,
        0xA46D, 0xA46E, 0xA46F, 0xA470, 0xA474, 0xA476, 0xA478, 0xA479,
        0xA47A, 0xA47C, 0xA47D, 0xA483, 0xA484, 0xA486, 0xA487, 0xA488,
        0xA48A, 0xA48B, 0xA48C, 0xA48D, 0xA48E, 0xA48F, 0xA490, 0xA494,
        0xA498, 0xA499, 0xA49A, 0xA49C, 0xA49D, 0xA4A3, 0xA4A4, 0xA4A6,
        0xA4A7, 0xA4A8, 0xA4A9, 0xA4AA, 0xA4AB, 0xA4AC, 0xA4AD, 0xA4AE,
        0xA4AF, 0xA4B0, 0xA4B1, 0xA4B4, 0xA4B5, 0xA4B6, 0xA4B7, 0xA4B8,
        0xA4B9, 0xA4BA, 0xA4BB, 0xA4BC, 0xA4BD, 0xA4C1, 0xA4C2, 0xA4C3,
        0xA4C4, 0xA4C5, 0xA4C6, 0xA4C7, 0xA4C8, 0xA4C9, 0xA4CA, 0xA4CB,
        0xA4CC, 0xA4CD, 0xA4CE, 0xA4CF, 0xA4D0, 0xA4D1, 0xA4D3, 0xA4D4,
        0xA4D5, 0xA4D6, 0xA4D7, 0xA4D8, 0xA4D9, 0xA4DA, 0xA4DB, 0xA4DC,
        0xA4DD, 0xA4E3, 0xA4E4, 0xA4E6, 0xA4E7, 0xA4EA, 0xA4EC, 0xA4ED,
        0xA4EE, 0xA4EF, 0xA4F0, 0xA4F4, 0xA4F6, 0xA4F9, 0xA4FA, 0xA4FB,
        0xA4FC, 0xA4FD, 0xA543, 0xA544, 0xA546, 0xA547, 0xA54A, 0xA54B,
        0xA54C, 0xA54D, 0xA54E, 0xA54F, 0xA550, 0xA554, 0xA558, 0xA559,
        0xA55A, 0xA55B, 0xA55C, 0xA55D, 0xA563, 0xA564, 0xA566, 0xA567,
        0xA568, 0xA56A, 0xA56B, 0xA56C, 0xA56D, 0xA56E, 0xA56F, 0xA570,
        0xA571, 0xA574, 0xA578, 0xA579, 0xA57A, 0xA57C, 0xA57D, 0xA582,
        0xA583, 0xA584, 0xA586, 0xA587, 0xA588, 0xA589, 0xA58A, 0xA58B,
        0xA58C, 0xA58D, 0xA58E, 0xA58F, 0xA590, 0xA591, 0xA593, 0xA594,
        0xA595, 0xA596, 0xA597, 0xA598, 0xA599, 0xA59A, 0xA59B, 0xA59C,
        0xA59D, 0xA5A4, 0xA5A6, 0xA5A7, 0xA5A8, 0xA5AA, 0xA5AB, 0xA5AC,
        0xA5AD, 0xA5AE, 0xA5AF, 0xA5B0, 0xA5B4, 0xA5B6, 0xA5B8, 0xA5B9,
        0xA5BA, 0xA5BB, 0xA5BC, 0xA5BD, 0xA5C2, 0xA5C3, 0xA5C4, 0xA5C6,
        0xA5C7, 0xA5C8, 0xA5C9, 0xA5CA, 0xA5CB, 0xA5CC, 0xA5CD, 0xA5CE,
        0xA5CF, 0xA5D0, 0xA5D1, 0xA5D3, 0xA5D4, 0xA5D5, 0xA5D7, 0xA5D8,
        0xA5D9, 0xA5DA, 0xA5DB, 0xA5DC, 0xA5DD, 0xA5E2, 0xA5E3, 0xA5E4,
        0xA5E5, 0xA5E6, 0xA5E7, 0xA5E8, 0xA5E9, 0xA5EA, 0xA5EB, 0xA5EC,
        0xA5ED, 0xA5EE, 0xA5EF, 0xA5F0, 0xA5F1, 0xA5F3, 0xA5F4, 0xA5F5,
        0xA5F7, 0xA5F8, 0xA5F9, 0xA5FA, 0xA5FB, 0xA5FC, 0xA5FD, 0xA643,
        0xA644, 0xA646, 0xA647, 0xA648, 0xA64A, 0xA64B, 0xA64C, 0xA64D,
        0xA64E, 0xA64F, 0xA650, 0xA654, 0xA655, 0xA656, 0xA657, 0xA658,
        0xA659, 0xA65A, 0xA65B, 0xA65C, 0xA65D, 0xA662, 0xA663, 0xA664,
        0xA666, 0xA667, 0xA668, 0xA669, 0xA66A, 0xA66B, 0xA66C, 0xA66D,
        0xA66E, 0xA66F, 0xA670, 0xA671, 0xA673, 0xA674, 0xA675, 0xA676,
        0xA677, 0xA678, 0xA679, 0xA67A, 0xA67B, 0xA67C, 0xA67D, 0xA683,
        0xA684, 0xA686, 0xA687, 0xA68C, 0xA68D, 0xA68E, 0xA68F, 0xA690,
        0xA694, 0xA696, 0xA698, 0xA699, 0xA69A, 0xA69D, 0xA6A2, 0xA6A3,
        0xA6A4, 0xA6A5, 0xA6A6, 0xA6A7, 0xA6A8, 0xA6AA, 0xA6AB, 0xA6AC,
        0xA6AD, 0xA6AE, 0xA6AF, 0xA6B0, 0xA6B1, 0xA6B3, 0xA6B4, 0xA6B5,
        0xA6B7, 0xA6B8, 0xA6B9, 0xA6BA, 0xA6BB, 0xA6BC, 0xA6BD, 0xA6C2,
        0xA6C3, 0xA6C4, 0xA6C5, 0xA6C6, 0xA6C7, 0xA6C8, 0xA6C9, 0xA6CA,
        0xA6CB, 0xA6CC, 0xA6CD, 0xA6CE, 0xA6CF, 0xA6D0, 0xA6D1, 0xA6D3,
        0xA6D4, 0xA6D5, 0xA6D6, 0xA6D7, 0xA6D8, 0xA6D9, 0xA6DA, 0xA6DB,
        0xA6DC, 0xA6DD, 0xA6E3, 0xA6E4, 0xA6E6, 0xA6E7, 0xA6E8, 0xA6EA,
        0xA6EB, 0xA6EC, 0xA6ED, 0xA6EE, 0xA6EF, 0xA6F0, 0xA6F1, 0xA6F3,
        0xA6F4, 0xA6F5, 0xA6F6, 0xA6F8, 0xA6F9, 0xA6FA, 0xA6FB, 0xA6FC,
        0xA6FD, 0xA742, 0xA743, 0xA744, 0xA746, 0xA747, 0xA748, 0xA74A,
        0xA74B, 0xA74C, 0xA74D, 0xA74E, 0xA74F, 0xA750, 0xA753, 0xA754,
        0xA756, 0xA758, 0xA759, 0xA75A, 0xA75B, 0xA75C, 0xA75D, 0xA763,
        0xA764, 0xA766, 0xA767, 0xA768, 0xA76A, 0xA76B, 0xA76C, 0xA76D,
        0xA76E, 0xA76F, 0xA770, 0xA774, 0xA776, 0xA777, 0xA778, 0xA779,
        0xA77A, 0xA77B, 0xA77C, 0xA77D, 0xA781, 0xA782, 0xA783, 0xA784,
        0xA785, 0xA786, 0xA787, 0xA788, 0xA789, 0xA78A, 0xA78B, 0xA78C,
        0xA78D, 0xA78E, 0xA78F, 0xA790, 0xA791, 0xA793, 0xA794, 0xA795,
        0xA796, 0xA797, 0xA798, 0xA799, 0xA79A, 0xA79B, 0xA79C, 0xA79D,
        0xA7A3, 0xA7A4, 0xA7A6, 0xA7A7, 0xA7A8, 0xA7AA, 0xA7AC, 0xA7AD,
        0xA7AE, 0xA7AF, 0xA7B0, 0xA7B4, 0xA7B6, 0xA7BA, 0xA7BB, 0xA7BC,
        0xA7BD, 0xA863, 0xA864, 0xA866, 0xA867, 0xA868, 0xA86A, 0xA86C,
        0xA86D, 0xA86E, 0xA86F, 0xA870, 0xA874, 0xA878, 0xA879, 0xA87A,
        0xA87B, 0xA87C, 0xA883, 0xA884, 0xA886, 0xA887, 0xA888, 0xA88A,
        0xA88B, 0xA88C, 0xA88D, 0xA88E, 0xA88F, 0xA890, 0xA894, 0xA898,
        0xA899, 0xA89A, 0xA89B, 0xA89C, 0xA89D, 0xA8A3, 0xA8A4, 0xA8A5,
        0xA8A6, 0xA8A7, 0xA8A8, 0xA8A9, 0xA8AA, 0xA8AB, 0xA8AC, 0xA8AD,
        0xA8AE, 0xA8AF, 0xA8B0, 0xA8B3, 0xA8B4, 0xA8B5, 0xA8B6, 0xA8B7,
        0xA8B8, 0xA8B9, 0xA8BA, 0xA8BB, 0xA8BC, 0xA8BD, 0xA8C1, 0xA8C2,
        0xA8C3, 0xA8C4, 0xA8C5, 0xA8C6, 0xA8C7, 0xA8C8, 0xA8C9, 0xA8CA,
        0xA8CB, 0xA8CC, 0xA8CD, 0xA8CE, 0xA8CF, 0xA8D0, 0xA8D1, 0xA8D3,
        0xA8D4, 0xA8D5, 0xA8D6, 0xA8D7, 0xA8D8, 0xA8D9, 0xA8DA, 0xA8DB,
        0xA8DC, 0xA8DD, 0xA8E3, 0xA8E4, 0xA8E6, 0xA8E7, 0xA8EA, 0xA8EB,
        0xA8EC, 0xA8ED, 0xA8EE, 0xA8EF, 0xA8F0, 0xA8F3, 0xA8F4, 0xA8F8,
        0xA8F9, 0xA8FA, 0xA8FB, 0xA8FC, 0xA8FD, 0xA942, 0xA943, 0xA944,
        0xA945, 0xA946, 0xA947, 0xA948, 0xA949, 0xA94A, 0xA94B, 0xA94C,
        0xA94D, 0xA94E, 0xA94F, 0xA950, 0xA951, 0xA953, 0xA954, 0xA955,
        0xA956, 0xA958, 0xA959, 0xA95A, 0xA95B, 0xA95C, 0xA95D, 0xA963,
        0xA964, 0xA965, 0xA966, 0xA967, 0xA968, 0xA969, 0xA96A, 0xA96B,
        0xA96C, 0xA96D, 0xA96E, 0xA96F, 0xA970, 0xA974, 0xA978, 0xA979,
        0xA97A, 0xA97B, 0xA97C, 0xA97D, 0xA981, 0xA982, 0xA983, 0xA984,
        0xA985, 0xA986, 0xA987, 0xA988, 0xA989, 0xA98A, 0xA98B, 0xA98C,
        0xA98D, 0xA98E, 0xA98F, 0xA990, 0xA991, 0xA993, 0xA994, 0xA995,
        0xA996, 0xA997, 0xA998, 0xA999, 0xA99A, 0xA99B, 0xA99C, 0xA99D,
        0xA9A3, 0xA9A4, 0xA9A6, 0xA9A7, 0xA9A8, 0xA9AA, 0xA9AB, 0xA9AC,
        0xA9AD, 0xA9AE, 0xA9AF, 0xA9B0, 0xA9B4, 0xA9B5, 0xA9B6, 0xA9B8,
        0xA9B9, 0xA9BA, 0xA9BB, 0xA9BC, 0xA9BD, 0xA9C1, 0xA9C2, 0xA9C3,
        0xA9C4, 0xA9C5, 0xA9C6, 0xA9C7, 0xA9C8, 0xA9C9, 0xA9CA, 0xA9CB,
        0xA9CC, 0xA9CD, 0xA9CE, 0xA9CF, 0xA9D0, 0xA9D1, 0xA9D3, 0xA9D4,
        0xA9D5, 0xA9D6, 0xA9D7, 0xA9D8, 0xA9D9, 0xA9DA, 0xA9DB, 0xA9DC,
        0xA9DD, 0xA9E1, 0xA9E2, 0xA9E3, 0xA9E4, 0xA9E5, 0xA9E6, 0xA9E7,
        0xA9E8, 0xA9E9, 0xA9EA, 0xA9EB, 0xA9EC, 0xA9ED, 0xA9EE, 0xA9EF,
        0xA9F0, 0xA9F1, 0xA9F3, 0xA9F4, 0xA9F5, 0xA9F6, 0xA9F7, 0xA9F8,
        0xA9F9, 0xA9FA, 0xA9FB, 0xA9FC, 0xA9FD, 0xAA42, 0xAA43, 0xAA44,
        0xAA45, 0xAA46, 0xAA47, 0xAA48, 0xAA49, 0xAA4A, 0xAA4B, 0xAA4C,
        0xAA4D, 0xAA4E, 0xAA4F, 0xAA50, 0xAA51, 0xAA53, 0xAA54, 0xAA55,
        0xAA56, 0xAA57, 0xAA58, 0xAA59, 0xAA5A, 0xAA5B, 0xAA5C, 0xAA5D,
        0xAA62, 0xAA63, 0xAA64, 0xAA65, 0xAA66, 0xAA67, 0xAA68, 0xAA69,
        0xAA6A, 0xAA6B, 0xAA6C, 0xAA6D, 0xAA6E, 0xAA6F, 0xAA70, 0xAA71,
        0xAA73, 0xAA74, 0xAA75, 0xAA76, 0xAA78, 0xAA79, 0xAA7A, 0xAA7B,
        0xAA7C, 0xAA7D, 0xAA83, 0xAA84, 0xAA86, 0xAA87, 0xAA88, 0xAA8A,
        0xAA8B, 0xAA8C, 0xAA8D, 0xAA8E, 0xAA8F, 0xAA90, 0xAA93, 0xAA94,
        0xAA96, 0xAA98, 0xAA99, 0xAA9A, 0xAA9B, 0xAA9C, 0xAA9D, 0xAAA1,
        0xAAA2, 0xAAA3, 0xAAA4, 0xAAA5, 0xAAA6, 0xAAA7, 0xAAA8, 0xAAA9,
        0xAAAA, 0xAAAB, 0xAAAC, 0xAAAD, 0xAAAE, 0xAAAF, 0xAAB0, 0xAAB1,
        0xAAB3, 0xAAB4, 0xAAB5, 0xAAB6, 0xAAB7, 0xAAB8, 0xAAB9, 0xAABA,
        0xAABB, 0xAABC, 0xAABD, 0xAAC1, 0xAAC2, 0xAAC3, 0xAAC4, 0xAAC5,
        0xAAC6, 0xAAC7, 0xAAC8, 0xAAC9, 0xAACA, 0xAACB, 0xAACC, 0xAACD,
        0xAACE, 0xAACF, 0xAAD0, 0xAAD1, 0xAAD3, 0xAAD4, 0xAAD5, 0xAAD6,
        0xAAD7, 0xAAD8, 0xAAD9, 0xAADA, 0xAADB, 0xAADC, 0xAADD, 0xAAE1,
        0xAAE2, 0xAAE3, 0xAAE4, 0xAAE5, 0xAAE6, 0xAAE7, 0xAAE8, 0xAAE9,
        0xAAEA, 0xAAEB, 0xAAEC, 0xAAED, 0xAAEE, 0xAAEF, 0xAAF0, 0xAAF1,
        0xAAF3, 0xAAF4, 0xAAF5, 0xAAF6, 0xAAF7, 0xAAF8, 0xAAF9, 0xAAFA,
        0xAAFB, 0xAAFC, 0xAAFD, 0xAB42, 0xAB43, 0xAB44, 0xAB45, 0xAB46,
        0xAB47, 0xAB48, 0xAB49, 0xAB4A, 0xAB4B, 0xAB4C, 0xAB4D, 0xAB4E,
        0xAB4F, 0xAB50, 0xAB51, 0xAB53, 0xAB54, 0xAB55, 0xAB56, 0xAB58,
        0xAB59, 0xAB5A, 0xAB5B, 0xAB5C, 0xAB5D, 0xAB62, 0xAB63, 0xAB64,
        0xAB66, 0xAB67, 0xAB68, 0xAB6A, 0xAB6B, 0xAB6C, 0xAB6D, 0xAB6E,
        0xAB6F, 0xAB70, 0xAB74, 0xAB75, 0xAB76, 0xAB77, 0xAB78, 0xAB79,
        0xAB7A, 0xAB7B, 0xAB7C, 0xAB7D, 0xAB81, 0xAB82, 0xAB83, 0xAB84,
        0xAB85, 0xAB86, 0xAB87, 0xAB88, 0xAB89, 0xAB8A, 0xAB8B, 0xAB8C,
        0xAB8D, 0xAB8E, 0xAB8F, 0xAB90, 0xAB91, 0xAB93, 0xAB94, 0xAB95,
        0xAB96, 0xAB97, 0xAB98, 0xAB99, 0xAB9A, 0xAB9B, 0xAB9C, 0xAB9D,
        0xABA3, 0xABA4, 0xABA6, 0xABA7, 0xABA8, 0xABAA, 0xABAB, 0xABAC,
        0xABAD, 0xABAE, 0xABAF, 0xABB0, 0xABB4, 0xABB6, 0xABB8, 0xABB9,
        0xABBA, 0xABBB, 0xABBC, 0xABBD, 0xAC63, 0xAC66, 0xAC67, 0xAC6C,
        0xAC6D, 0xAC6E, 0xAC6F, 0xAC70, 0xAC74, 0xAC78, 0xAC79, 0xAC7A,
        0xAC7C, 0xAC7D, 0xAC83, 0xAC84, 0xAC86, 0xAC87, 0xAC88, 0xAC8A,
        0xAC8B, 0xAC8C, 0xAC8D, 0xAC8E, 0xAC8F, 0xAC90, 0xAC94, 0xAC98,
        0xAC99, 0xAC9A, 0xAC9B, 0xAC9C, 0xAC9D, 0xACA3, 0xACA4, 0xACA6,
        0xACA7, 0xACA8, 0xACAA, 0xACAB, 0xACAC, 0xACAD, 0xACAE, 0xACAF,
        0xACB0, 0xACB4, 0xACB6, 0xACB8, 0xACB9, 0xACBA, 0xACBB, 0xACBC,
        0xACBD, 0xACC2, 0xACC3, 0xACC4, 0xACC6, 0xACC7, 0xACC8, 0xACCA,
        0xACCB, 0xACCC, 0xACCD, 0xACCE, 0xACCF, 0xACD0, 0xACD3, 0xACD4,
        0xACD5, 0xACD6, 0xACD8, 0xACD9, 0xACDA, 0xACDB, 0xACDC, 0xACDD,
        0xACE6, 0xACE7, 0xACEA, 0xACED, 0xACEE, 0xACEF, 0xACF0, 0xACF4,
        0xACF8, 0xACF9, 0xACFA, 0xACFB, 0xACFD, 0xAD43, 0xAD44, 0xAD46,
        0xAD47, 0xAD48, 0xAD4A, 0xAD4B, 0xAD4C, 0xAD4D, 0xAD4E, 0xAD4F,
        0xAD50, 0xAD54, 0xAD58, 0xAD59, 0xAD5A, 0xAD5B, 0xAD5C, 0xAD5D,
        0xAD63, 0xAD64, 0xAD66, 0xAD67, 0xAD68, 0xAD6A, 0xAD6B, 0xAD6C,
        0xAD6D, 0xAD6E, 0xAD6F, 0xAD70, 0xAD74, 0xAD78, 0xAD79, 0xAD7A,
        0xAD7B, 0xAD7C, 0xAD7D, 0xAD82, 0xAD83, 0xAD84, 0xAD86, 0xAD87,
        0xAD88, 0xAD8A, 0xAD8B, 0xAD8C, 0xAD8D, 0xAD8E, 0xAD8F, 0xAD90,
        0xAD91, 0xAD93, 0xAD94, 0xAD95, 0xAD96, 0xAD98, 0xAD99, 0xAD9A,
        0xAD9B, 0xAD9C, 0xAD9D, 0xADA4, 0xADA6, 0xADA7, 0xADA8, 0xADAA,
        0xADAC, 0xADAD, 0xADAE, 0xADAF, 0xADB0, 0xADB4, 0xADB6, 0xADB8,
        0xADB9, 0xADBA, 0xADBC, 0xADBD, 0xADC3, 0xADC4, 0xADC6, 0xADC7,
        0xADC8, 0xADCA, 0xADCB, 0xADCC, 0xADCD, 0xADCE, 0xADCF, 0xADD0,
        0xADD1, 0xADD3, 0xADD4, 0xADD5, 0xADD6, 0xADD8, 0xADD9, 0xADDA,
        0xADDB, 0xADDC, 0xADDD, 0xADE2, 0xADE3, 0xADE4, 0xADE6, 0xADE7,
        0xADE8, 0xADEA, 0xADEB, 0xADEC, 0xADED, 0xADEE, 0xADEF, 0xADF0,
        0xADF3, 0xADF4, 0xADF7, 0xADF8, 0xADF9, 0xADFA, 0xADFB, 0xADFC,
        0xADFD, 0xAE42, 0xAE43, 0xAE44, 0xAE46, 0xAE47, 0xAE48, 0xAE4A,
        0xAE4B, 0xAE4C, 0xAE4D, 0xAE4E, 0xAE4F, 0xAE50, 0xAE54, 0xAE56,
        0xAE57, 0xAE58, 0xAE59, 0xAE5A, 0xAE5B, 0xAE5C, 0xAE5D, 0xAE63,
        0xAE64, 0xAE66, 0xAE67, 0xAE68, 0xAE6A, 0xAE6B, 0xAE6C, 0xAE6D,
        0xAE6E, 0xAE6F, 0xAE70, 0xAE74, 0xAE76, 0xAE78, 0xAE79, 0xAE7A,
        0xAE7B, 0xAE7C, 0xAE7D, 0xAE83, 0xAE84, 0xAE86, 0xAE87, 0xAE8A,
        0xAE8B, 0xAE8C, 0xAE8D, 0xAE8E, 0xAE8F, 0xAE90, 0xAE94, 0xAE96,
        0xAE98, 0xAE9A, 0xAE9D, 0xAEA2, 0xAEA3, 0xAEA4, 0xAEA5, 0xAEA6,
        0xAEA7, 0xAEA8, 0xAEA9, 0xAEAA, 0xAEAB, 0xAEAC, 0xAEAD, 0xAEAE,
        0xAEAF, 0xAEB0, 0xAEB1, 0xAEB3, 0xAEB4, 0xAEB5, 0xAEB7, 0xAEB8,
        0xAEB9, 0xAEBA, 0xAEBB, 0xAEBC, 0xAEBD, 0xAEC3, 0xAEC4, 0xAEC6,
        0xAEC7, 0xAEC8, 0xAECA, 0xAECB, 0xAECC, 0xAECD, 0xAECE, 0xAECF,
        0xAED0, 0xAED3, 0xAED4, 0xAED5, 0xAED6, 0xAED8, 0xAED9, 0xAEDA,
        0xAEDB, 0xAEDC, 0xAEDD, 0xAEE3, 0xAEE4, 0xAEE6, 0xAEE7, 0xAEE8,
        0xAEEA, 0xAEEB, 0xAEEC, 0xAEED, 0xAEEE, 0xAEEF, 0xAEF0, 0xAEF4,
        0xAEF6, 0xAEF8, 0xAEF9, 0xAEFA, 0xAEFB, 0xAEFC, 0xAEFD, 0xAF43,
        0xAF44, 0xAF45, 0xAF46, 0xAF47, 0xAF48, 0xAF4A, 0xAF4B, 0xAF4C,
        0xAF4D, 0xAF4E, 0xAF4F, 0xAF50, 0xAF53, 0xAF54, 0xAF56, 0xAF58,
        0xAF59, 0xAF5A, 0xAF5B, 0xAF5C, 0xAF5D, 0xAF63, 0xAF64, 0xAF66,
        0xAF67, 0xAF68, 0xAF6B, 0xAF6C, 0xAF6D, 0xAF6E, 0xAF6F, 0xAF70,
        0xAF74, 0xAF76, 0xAF78, 0xAF79, 0xAF7A, 0xAF7B, 0xAF7C, 0xAF7D,
        0xAF81, 0xAF82, 0xAF83, 0xAF84, 0xAF85, 0xAF86, 0xAF87, 0xAF88,
        0xAF89, 0xAF8A, 0xAF8B, 0xAF8C, 0xAF8D, 0xAF8E, 0xAF8F, 0xAF90,
        0xAF91, 0xAF93, 0xAF94, 0xAF95, 0xAF96, 0xAF97, 0xAF98, 0xAF99,
        0xAF9A, 0xAF9B, 0xAF9C, 0xAF9D, 0xAFA3, 0xAFA4, 0xAFA6, 0xAFA7,
        0xAFAA, 0xAFAB, 0xAFAC, 0xAFAD, 0xAFAE, 0xAFAF, 0xAFB4, 0xAFB6,
        0xAFB8, 0xAFB9, 0xAFBA, 0xAFBB, 0xAFBD, 0xB063, 0xB066, 0xB067,
        0xB068, 0xB06A, 0xB06B, 0xB06C, 0xB06D, 0xB06E, 0xB06F, 0xB070,
        0xB074, 0xB075, 0xB078, 0xB079, 0xB07A, 0xB07B, 0xB07C, 0xB083,
        0xB084, 0xB086, 0xB087, 0xB088, 0xB08A, 0xB08B, 0xB08C, 0xB08D,
        0xB08E, 0xB08F, 0xB090, 0xB094, 0xB095, 0xB098, 0xB099, 0xB09A,
        0xB09B, 0xB09C, 0xB09D, 0xB0A1, 0xB0A2, 0xB0A3, 0xB0A4, 0xB0A5,
        0xB0A6, 0xB0A7, 0xB0A8, 0xB0A9, 0xB0AA, 0xB0AB, 0xB0AC, 0xB0AD,
        0xB0AE, 0xB0AF, 0xB0B0, 0xB0B1, 0xB0B3, 0xB0B4, 0xB0B5, 0xB0B6,
        0xB0B8, 0xB0B9, 0xB0BA, 0xB0BB, 0xB0BC, 0xB0BD, 0xB0C1, 0xB0C2,
        0xB0C3, 0xB0C4, 0xB0C5, 0xB0C6, 0xB0C7, 0xB0C8, 0xB0C9, 0xB0CA,
        0xB0CB, 0xB0CC, 0xB0CD, 0xB0CE, 0xB0CF, 0xB0D0, 0xB0D1, 0xB0D3,
        0xB0D4, 0xB0D5, 0xB0D6, 0xB0D7, 0xB0D8, 0xB0D9, 0xB0DA, 0xB0DB,
        0xB0DC, 0xB0DD, 0xB0E3, 0xB0E4, 0xB0E6, 0xB0E7, 0xB0E8, 0xB0EA,
        0xB0EC, 0xB0ED, 0xB0EE, 0xB0EF, 0xB0F0, 0xB0F4, 0xB0F5, 0xB0F8,
        0xB0F9, 0xB0FA, 0xB0FB, 0xB0FC, 0xB0FD, 0xB142, 0xB143, 0xB144,
        0xB146, 0xB147, 0xB148, 0xB14A, 0xB14B, 0xB14C, 0xB14D, 0xB14E,
        0xB14F, 0xB150, 0xB151, 0xB153, 0xB154, 0xB155, 0xB156, 0xB158,
        0xB159, 0xB15A, 0xB15B, 0xB15C, 0xB15D, 0xB161, 0xB162, 0xB163,
        0xB164, 0xB165, 0xB166, 0xB167, 0xB168, 0xB169, 0xB16A, 0xB16B,
        0xB16C, 0xB16D, 0xB16E, 0xB16F, 0xB170, 0xB171, 0xB173, 0xB174,
        0xB175, 0xB176, 0xB177, 0xB178, 0xB179, 0xB17A, 0xB17B, 0xB17C,
        0xB17D, 0xB181, 0xB182, 0xB183, 0xB184, 0xB185, 0xB186, 0xB187,
        0xB188, 0xB189, 0xB18A, 0xB18B, 0xB18C, 0xB18D, 0xB18E, 0xB18F,
        0xB190, 0xB191, 0xB193, 0xB194, 0xB195, 0xB196, 0xB197, 0xB198,
        0xB199, 0xB19A, 0xB19B, 0xB19C, 0xB19D, 0xB1A3, 0xB1A4, 0xB1A6,
        0xB1A7, 0xB1AA, 0xB1AC, 0xB1AD, 0xB1AE, 0xB1AF, 0xB1B0, 0xB1B4,
        0xB1B5, 0xB1B6, 0xB1B8, 0xB1B9, 0xB1BA, 0xB1BB, 0xB1BC, 0xB1BD,
        0xB1C3, 0xB1C4, 0xB1C6, 0xB1C7, 0xB1C8, 0xB1C9, 0xB1CA, 0xB1CB,
        0xB1CC, 0xB1CD, 0xB1CE, 0xB1CF, 0xB1D0, 0xB1D1, 0xB1D3, 0xB1D4,
        0xB1D5, 0xB1D7, 0xB1D8, 0xB1D9, 0xB1DA, 0xB1DB, 0xB1DC, 0xB1DD,
        0xB1E2, 0xB1E3, 0xB1E4, 0xB1E5, 0xB1E6, 0xB1E7, 0xB1E8, 0xB1E9,
        0xB1EA, 0xB1EB, 0xB1EC, 0xB1ED, 0xB1EE, 0xB1EF, 0xB1F0, 0xB1F1,
        0xB1F3, 0xB1F4, 0xB1F5, 0xB1F7, 0xB1F8, 0xB1F9, 0xB1FA, 0xB1FB,
        0xB1FC, 0xB1FD, 0xB242, 0xB243, 0xB244, 0xB246, 0xB247, 0xB248,
        0xB24A, 0xB24B, 0xB24C, 0xB24D, 0xB24E, 0xB24F, 0xB250, 0xB254,
        0xB255, 0xB256, 0xB257, 0xB258, 0xB259, 0xB25A, 0xB25B, 0xB25C,
        0xB25D, 0xB262, 0xB263, 0xB264, 0xB265, 0xB266, 0xB267, 0xB268,
        0xB269, 0xB26A, 0xB26B, 0xB26C, 0xB26D, 0xB26E, 0xB26F, 0xB270,
        0xB271, 0xB273, 0xB274, 0xB275, 0xB276, 0xB277, 0xB278, 0xB279,
        0xB27A, 0xB27B, 0xB27C, 0xB27D, 0xB283, 0xB284, 0xB286, 0xB287,
        0xB288, 0xB28A, 0xB28B, 0xB28C, 0xB28D, 0xB28E, 0xB28F, 0xB290,
        0xB294, 0xB295, 0xB296, 0xB298, 0xB299, 0xB29A, 0xB29B, 0xB29C,
        0xB29D, 0xB2A2, 0xB2A3, 0xB2A4, 0xB2A5, 0xB2A6, 0xB2A7, 0xB2A8,
        0xB2A9, 0xB2AA, 0xB2AB, 0xB2AC, 0xB2AD, 0xB2AE, 0xB2AF, 0xB2B0,
        0xB2B1, 0xB2B3, 0xB2B4, 0xB2B5, 0xB2B7, 0xB2B8, 0xB2B9, 0xB2BA,
        0xB2BB, 0xB2BC, 0xB2BD, 0xB2C2, 0xB2C3, 0xB2C4, 0xB2C5, 0xB2C6,
        0xB2C7, 0xB2C8, 0xB2C9, 0xB2CA, 0xB2CB, 0xB2CC, 0xB2CD, 0xB2CE,
        0xB2CF, 0xB2D0, 0xB2D1, 0xB2D3, 0xB2D4, 0xB2D5, 0xB2D6, 0xB2D7,
        0xB2D8, 0xB2D9, 0xB2DA, 0xB2DB, 0xB2DC, 0xB2DD, 0xB2E2, 0xB2E3,
        0xB2E4, 0xB2E6, 0xB2E7, 0xB2E8, 0xB2E9, 0xB2EA, 0xB2EB, 0xB2EC,
        0xB2ED, 0xB2EE, 0xB2EF, 0xB2F0, 0xB2F1, 0xB2F3, 0xB2F4, 0xB2F5,
        0xB2F6, 0xB2F7, 0xB2F8, 0xB2F9, 0xB2FA, 0xB2FB, 0xB2FC, 0xB2FD,
        0xB341, 0xB342, 0xB343, 0xB344, 0xB345, 0xB346, 0xB347, 0xB348,
        0xB349, 0xB34A, 0xB34B, 0xB34C, 0xB34D, 0xB34E, 0xB34F, 0xB350,
        0xB351, 0xB353, 0xB354, 0xB355, 0xB356, 0xB358, 0xB359, 0xB35A,
        0xB35B, 0xB35C, 0xB35D, 0xB363, 0xB364, 0xB366, 0xB367, 0xB368,
        0xB36A, 0xB36C, 0xB36D, 0xB36E, 0xB36F, 0xB374, 0xB375, 0xB376,
        0xB377, 0xB378, 0xB379, 0xB37A, 0xB37B, 0xB37C, 0xB37D, 0xB382,
        0xB383, 0xB384, 0xB386, 0xB387, 0xB388, 0xB38A, 0xB38B, 0xB38C,
        0xB38D, 0xB38E, 0xB38F, 0xB390, 0xB393, 0xB394, 0xB395, 0xB396,
        0xB397, 0xB398, 0xB399, 0xB39A, 0xB39B, 0xB39C, 0xB39D, 0xB3A3,
        0xB3A4, 0xB3A6, 0xB3A7, 0xB3A8, 0xB3AA, 0xB3AB, 0xB3AC, 0xB3AD,
        0xB3AE, 0xB3AF, 0xB3B0, 0xB3B4, 0xB3B6, 0xB3B8, 0xB3B9, 0xB3BA,
        0xB3BB, 0xB3BC, 0xB3BD, 0xB463, 0xB464, 0xB468, 0xB46C, 0xB46D,
        0xB46E, 0xB46F, 0xB474, 0xB478, 0xB479, 0xB47A, 0xB47D, 0xB483,
        0xB484, 0xB486, 0xB487, 0xB488, 0xB48A, 0xB48B, 0xB48C, 0xB48D,
        0xB48E, 0xB48F, 0xB490, 0xB494, 0xB498, 0xB499, 0xB49A, 0xB49B,
        0xB49C, 0xB49D, 0xB4A3, 0xB4A4, 0xB4A6, 0xB4A7, 0xB4A8, 0xB4AA,
        0xB4AB, 0xB4AD, 0xB4AE, 0xB4AF, 0xB4B0, 0xB4B4, 0xB4B6, 0xB4B8,
        0xB4B9, 0xB4BA, 0xB4BC, 0xB4C2, 0xB4C3, 0xB4C4, 0xB4C6, 0xB4C7,
        0xB4C8, 0xB4CA, 0xB4CB, 0xB4CC, 0xB4CD, 0xB4CE, 0xB4CF, 0xB4D0,
        0xB4D1, 0xB4D4, 0xB4D5, 0xB4D6, 0xB4D7, 0xB4D8, 0xB4D9, 0xB4DA,
        0xB4DB, 0xB4DC, 0xB4DD, 0xB4E3, 0xB4E4, 0xB4E7, 0xB4EC, 0xB4ED,
        0xB4EE, 0xB4EF, 0xB4F0, 0xB4F9, 0xB4FB, 0xB4FD, 0xB543, 0xB544,
        0xB546, 0xB547, 0xB548, 0xB54A, 0xB54B, 0xB54C, 0xB54D, 0xB54E,
        0xB54F, 0xB550, 0xB554, 0xB556, 0xB558, 0xB559, 0xB55A, 0xB55B,
        0xB55C, 0xB55D, 0xB564, 0xB566, 0xB567, 0xB568, 0xB56A, 0xB56D,
        0xB56E, 0xB56F, 0xB570, 0xB578, 0xB579, 0xB57A, 0xB582, 0xB583,
        0xB584, 0xB586, 0xB587, 0xB588, 0xB58A, 0xB58B, 0xB58C, 0xB58D,
        0xB58E, 0xB58F, 0xB590, 0xB594, 0xB597, 0xB598, 0xB599, 0xB59A,
        0xB59B, 0xB59C, 0xB59D, 0xB5A3, 0xB5A4, 0xB5A6, 0xB5A7, 0xB5A8,
        0xB5AC, 0xB5AE, 0xB5AF, 0xB5B4, 0xB5B6, 0xB5B8, 0xB5BA, 0xB5BB,
        0xB5BC, 0xB5BD, 0xB5C3, 0xB5C4, 0xB5C6, 0xB5C7, 0xB5C8, 0xB5CA,
        0xB5CB, 0xB5CC, 0xB5CD, 0xB5CE, 0xB5CF, 0xB5D0, 0xB5D4, 0xB5D8,
        0xB5D9, 0xB5DA, 0xB5DB, 0xB5DC, 0xB5DD, 0xB5E3, 0xB5E4, 0xB5E6,
        0xB5E7, 0xB5E8, 0xB5E9, 0xB5EA, 0xB5EB, 0xB5EC, 0xB5ED, 0xB5EE,
        0xB5EF, 0xB5F0, 0xB5F3, 0xB5F4, 0xB5F6, 0xB5F8, 0xB5F9, 0xB5FA,
        0xB5FB, 0xB5FC, 0xB5FD, 0xB643, 0xB644, 0xB646, 0xB647, 0xB648,
        0xB64A, 0xB64B, 0xB64C, 0xB64D, 0xB64E, 0xB64F, 0xB650, 0xB654,
        0xB656, 0xB658, 0xB659, 0xB65A, 0xB65B, 0xB65C, 0xB65D, 0xB663,
        0xB664, 0xB666, 0xB667, 0xB668, 0xB66A, 0xB66B, 0xB66C, 0xB66D,
        0xB66E, 0xB66F, 0xB670, 0xB674, 0xB676, 0xB678, 0xB679, 0xB67A,
        0xB67B, 0xB67C, 0xB67D, 0xB683, 0xB684, 0xB686, 0xB687, 0xB688,
        0xB68C, 0xB68D, 0xB68E, 0xB68F, 0xB690, 0xB694, 0xB696, 0xB698,
        0xB699, 0xB69A, 0xB69B, 0xB69C, 0xB69D, 0xB6A3, 0xB6A4, 0xB6A6,
        0xB6A7, 0xB6A8, 0xB6AA, 0xB6AB, 0xB6AC, 0xB6AD, 0xB6AE, 0xB6AF,
        0xB6B0, 0xB6B4, 0xB6B5, 0xB6B8, 0xB6B9, 0xB6BA, 0xB6BB, 0xB6BC,
        0xB6BD, 0xB6C3, 0xB6C4, 0xB6C6, 0xB6C7, 0xB6C8, 0xB6CA, 0xB6CB,
        0xB6CC, 0xB6CD, 0xB6CE, 0xB6CF, 0xB6D0, 0xB6D4, 0xB6D5, 0xB6D6,
        0xB6D8, 0xB6D9, 0xB6DA, 0xB6DB, 0xB6DC, 0xB6DD, 0xB6E3, 0xB6E4,
        0xB6E6, 0xB6E7, 0xB6E8, 0xB6EA, 0xB6EB, 0xB6EC, 0xB6ED, 0xB6EE,
        0xB6EF, 0xB6F0, 0xB6F4, 0xB6F6, 0xB6F8, 0xB6F9, 0xB6FA, 0xB6FB,
        0xB6FC, 0xB6FD, 0xB743, 0xB744, 0xB746, 0xB747, 0xB748, 0xB74A,
        0xB74B, 0xB74C, 0xB74D, 0xB74E, 0xB74F, 0xB750, 0xB754, 0xB756,
        0xB758, 0xB75A, 0xB75B, 0xB75C, 0xB75D, 0xB763, 0xB764, 0xB766,
        0xB767, 0xB768, 0xB76A, 0xB76B, 0xB76C, 0xB76D, 0xB76E, 0xB770,
        0xB774, 0xB776, 0xB782, 0xB783, 0xB784, 0xB786, 0xB787, 0xB788,
        0xB78A, 0xB78B, 0xB78C, 0xB78D, 0xB78E, 0xB78F, 0xB790, 0xB793,
        0xB794, 0xB796, 0xB797, 0xB798, 0xB799, 0xB79A, 0xB79B, 0xB79C,
        0xB79D, 0xB7A3, 0xB7A4, 0xB7A6, 0xB7A7, 0xB7A8, 0xB7AC, 0xB7AD,
        0xB7AE, 0xB7AF, 0xB7B4, 0xB7B9, 0xB7BA, 0xB7BB, 0xB7BD, 0xB863,
        0xB864, 0xB866, 0xB86A, 0xB86C, 0xB86D, 0xB86E, 0xB86F, 0xB870,
        0xB874, 0xB879, 0xB87A, 0xB87B, 0xB87C, 0xB87D, 0xB883, 0xB884,
        0xB886, 0xB887, 0xB888, 0xB88A, 0xB88B, 0xB88C, 0xB88D, 0xB88E,
        0xB88F, 0xB890, 0xB894, 0xB898, 0xB899, 0xB89A, 0xB89B, 0xB89C,
        0xB89D, 0xB8A3, 0xB8A4, 0xB8A6, 0xB8A8, 0xB8AA, 0xB8AB, 0xB8AC,
        0xB8AD, 0xB8AE, 0xB8AF, 0xB8B0, 0xB8B3, 0xB8B4, 0xB8B5, 0xB8B6,
        0xB8B8, 0xB8B9, 0xB8BA, 0xB8BB, 0xB8BC, 0xB8BD, 0xB8C2, 0xB8C3,
        0xB8C4, 0xB8C6, 0xB8C7, 0xB8C8, 0xB8CA, 0xB8CB, 0xB8CC, 0xB8CD,
        0xB8CE, 0xB8CF, 0xB8D0, 0xB8D1, 0xB8D3, 0xB8D4, 0xB8D5, 0xB8D6,
        0xB8D7, 0xB8D8, 0xB8D9, 0xB8DA, 0xB8DB, 0xB8DC, 0xB8DD, 0xB8E3,
        0xB8E4, 0xB8E6, 0xB8E7, 0xB8E8, 0xB8EA, 0xB8EC, 0xB8ED, 0xB8EE,
        0xB8EF, 0xB8F0, 0xB8F4, 0xB8F6, 0xB8F9, 0xB8FA, 0xB8FB, 0xB8FC,
        0xB8FD, 0xB943, 0xB944, 0xB946, 0xB947, 0xB948, 0xB94A, 0xB94B,
        0xB94C, 0xB94D, 0xB94E, 0xB94F, 0xB950, 0xB954, 0xB956, 0xB958,
        0xB959, 0xB95A, 0xB95B, 0xB95C, 0xB95D, 0xB962, 0xB963, 0xB964,
        0xB966, 0xB967, 0xB968, 0xB96A, 0xB96B, 0xB96C, 0xB96D, 0xB96E,
        0xB96F, 0xB970, 0xB974, 0xB975, 0xB978, 0xB979, 0xB97A, 0xB97B,
        0xB97C, 0xB97D, 0xB982, 0xB983, 0xB984, 0xB985, 0xB986, 0xB987,
        0xB988, 0xB989, 0xB98A, 0xB98B, 0xB98C, 0xB98D, 0xB98E, 0xB98F,
        0xB990, 0xB991, 0xB993, 0xB994, 0xB995, 0xB996, 0xB997, 0xB998,
        0xB999, 0xB99A, 0xB99B, 0xB99C, 0xB99D, 0xB9A3, 0xB9A4, 0xB9A6,
        0xB9A7, 0xB9A8, 0xB9AA, 0xB9AC, 0xB9AD, 0xB9AE, 0xB9AF, 0xB9B0,
        0xB9B4, 0xB9B6, 0xB9BA, 0xB9BB, 0xB9BC, 0xB9C3, 0xB9C4, 0xB9C5,
        0xB9C6, 0xB9C7, 0xB9C8, 0xB9CA, 0xB9CB, 0xB9CC, 0xB9CD, 0xB9CE,
        0xB9CF, 0xB9D0, 0xB9D1, 0xB9D4, 0xB9D6, 0xB9D8, 0xB9D9, 0xB9DA,
        0xB9DB, 0xB9DC, 0xB9DD, 0xB9E2, 0xB9E3, 0xB9E4, 0xB9E5, 0xB9E6,
        0xB9E7, 0xB9E8, 0xB9E9, 0xB9EA, 0xB9EB, 0xB9EC, 0xB9ED, 0xB9EE,
        0xB9EF, 0xB9F0, 0xB9F1, 0xB9F3, 0xB9F4, 0xB9F5, 0xB9F8, 0xB9F9,
        0xB9FA, 0xB9FB, 0xB9FC, 0xB9FD, 0xBA42, 0xBA43, 0xBA44, 0xBA46,
        0xBA47, 0xBA48, 0xBA4A, 0xBA4B, 0xBA4C, 0xBA4D, 0xBA4E, 0xBA4F,
        0xBA50, 0xBA54, 0xBA56, 0xBA58, 0xBA59, 0xBA5A, 0xBA5B, 0xBA5C,
        0xBA5D, 0xBA63, 0xBA64, 0xBA66, 0xBA67, 0xBA68, 0xBA69, 0xBA6A,
        0xBA6B, 0xBA6C, 0xBA6D, 0xBA6E, 0xBA6F, 0xBA70, 0xBA71, 0xBA73,
        0xBA74, 0xBA75, 0xBA76, 0xBA78, 0xBA79, 0xBA7A, 0xBA7B, 0xBA7C,
        0xBA7D, 0xBA83, 0xBA84, 0xBA86, 0xBA87, 0xBA88, 0xBA8C, 0xBA8D,
        0xBA8E, 0xBA8F, 0xBA90, 0xBA94, 0xBA96, 0xBA98, 0xBA99, 0xBA9A,
        0xBA9B, 0xBA9C, 0xBA9D, 0xBAA2, 0xBAA3, 0xBAA4, 0xBAA5, 0xBAA6,
        0xBAA7, 0xBAA8, 0xBAA9, 0xBAAA, 0xBAAB, 0xBAAC, 0xBAAD, 0xBAAE,
        0xBAAF, 0xBAB0, 0xBAB1, 0xBAB3, 0xBAB4, 0xBAB5, 0xBAB7, 0xBAB8,
        0xBAB9, 0xBABA, 0xBABB, 0xBABC, 0xBABD, 0xBAC2, 0xBAC3, 0xBAC4,
        0xBAC5, 0xBAC6, 0xBAC7, 0xBAC8, 0xBAC9, 0xBACA, 0xBACB, 0xBACC,
        0xBACD, 0xBACE, 0xBACF, 0xBAD0, 0xBAD1, 0xBAD3, 0xBAD4, 0xBAD5,
        0xBAD6, 0xBAD7, 0xBAD8, 0xBAD9, 0xBADA, 0xBADB, 0xBADC, 0xBADD,
        0xBAE3, 0xBAE4, 0xBAE6, 0xBAE7, 0xBAE8, 0xBAEA, 0xBAEB, 0xBAEC,
        0xBAED, 0xBAEE, 0xBAEF, 0xBAF0, 0xBAF4, 0xBAF6, 0xBAF7, 0xBAF8,
        0xBAF9, 0xBAFA, 0xBAFB, 0xBAFC, 0xBAFD, 0xBB42, 0xBB43, 0xBB44,
        0xBB46, 0xBB47, 0xBB48, 0xBB4A, 0xBB4B, 0xBB4C, 0xBB4D, 0xBB4E,
        0xBB4F, 0xBB50, 0xBB53, 0xBB54, 0xBB55, 0xBB56, 0xBB57, 0xBB58,
        0xBB59, 0xBB5A, 0xBB5B, 0xBB5C, 0xBB5D, 0xBB63, 0xBB64, 0xBB66,
        0xBB67, 0xBB68, 0xBB6A, 0xBB6B, 0xBB6C, 0xBB6D, 0xBB6E, 0xBB6F,
        0xBB70, 0xBB74, 0xBB76, 0xBB78, 0xBB79, 0xBB7A, 0xBB7B, 0xBB7C,
        0xBB7D, 0xBB81, 0xBB82, 0xBB83, 0xBB84, 0xBB85, 0xBB86, 0xBB87,
        0xBB88, 0xBB89, 0xBB8A, 0xBB8B, 0xBB8C, 0xBB8D, 0xBB8E, 0xBB8F,
        0xBB90, 0xBB91, 0xBB93, 0xBB94, 0xBB95, 0xBB96, 0xBB97, 0xBB98,
        0xBB99, 0xBB9A, 0xBB9B, 0xBB9C, 0xBB9D, 0xBBA3, 0xBBA4, 0xBBA6,
        0xBBA7, 0xBBAA, 0xBBAC, 0xBBAD, 0xBBAE, 0xBBAF, 0xBBB0, 0xBBB4,
        0xBBB6, 0xBBB9, 0xBBBA, 0xBBBD, 0xBC63, 0xBC64, 0xBC66, 0xBC68,
        0xBC6A, 0xBC6B, 0xBC6D, 0xBC6E, 0xBC6F, 0xBC70, 0xBC74, 0xBC78,
        0xBC79, 0xBC7A, 0xBC7B, 0xBC7C, 0xBC7D, 0xBC83, 0xBC84, 0xBC86,
        0xBC87, 0xBC88, 0xBC8A, 0xBC8B, 0xBC8C, 0xBC8D, 0xBC8E, 0xBC8F,
        0xBC90, 0xBC94, 0xBC98, 0xBC99, 0xBC9A, 0xBC9B, 0xBC9C, 0xBC9D,
        0xBCA2, 0xBCA3, 0xBCA4, 0xBCA6, 0xBCA7, 0xBCA8, 0xBCA9, 0xBCAA,
        0xBCAB, 0xBCAC, 0xBCAD, 0xBCAE, 0xBCAF, 0xBCB0, 0xBCB1, 0xBCB3,
        0xBCB4, 0xBCB5, 0xBCB6, 0xBCB8, 0xBCB9, 0xBCBA, 0xBCBB, 0xBCBC,
        0xBCBD, 0xBCC1, 0xBCC2, 0xBCC3, 0xBCC4, 0xBCC5, 0xBCC6, 0xBCC7,
        0xBCC8, 0xBCC9, 0xBCCA, 0xBCCB, 0xBCCC, 0xBCCD, 0xBCCE, 0xBCCF,
        0xBCD0, 0xBCD1, 0xBCD3, 0xBCD4, 0xBCD5, 0xBCD6, 0xBCD7, 0xBCD8,
        0xBCD9, 0xBCDA, 0xBCDB, 0xBCDC, 0xBCDD, 0xBCE3, 0xBCE4, 0xBCE6,
        0xBCE7, 0xBCE8, 0xBCEA, 0xBCEB, 0xBCEC, 0xBCED, 0xBCEE, 0xBCEF,
        0xBCF0, 0xBCF4, 0xBCF8, 0xBCF9, 0xBCFA, 0xBCFB, 0xBCFC, 0xBCFD,
        0xBD42, 0xBD43, 0xBD44, 0xBD45, 0xBD46, 0xBD47, 0xBD48, 0xBD49,
        0xBD4A, 0xBD4B, 0xBD4C, 0xBD4D, 0xBD4E, 0xBD4F, 0xBD50, 0xBD51,
        0xBD53, 0xBD54, 0xBD55, 0xBD56, 0xBD58, 0xBD59, 0xBD5A, 0xBD5B,
        0xBD5C, 0xBD5D, 0xBD62, 0xBD63, 0xBD64, 0xBD65, 0xBD66, 0xBD67,
        0xBD68, 0xBD69, 0xBD6A, 0xBD6B, 0xBD6C, 0xBD6D, 0xBD6E, 0xBD6F,
        0xBD70, 0xBD71, 0xBD73, 0xBD74, 0xBD75, 0xBD77, 0xBD78, 0xBD79,
        0xBD7A, 0xBD7B, 0xBD7C, 0xBD7D, 0xBD81, 0xBD82, 0xBD83, 0xBD84,
        0xBD85, 0xBD86, 0xBD87, 0xBD88, 0xBD89, 0xBD8A, 0xBD8B, 0xBD8C,
        0xBD8D, 0xBD8E, 0xBD8F, 0xBD90, 0xBD91, 0xBD93, 0xBD94, 0xBD95,
        0xBD96, 0xBD97, 0xBD98, 0xBD99, 0xBD9A, 0xBD9B, 0xBD9C, 0xBD9D,
        0xBDA3, 0xBDA4, 0xBDA6, 0xBDA7, 0xBDA8, 0xBDAA, 0xBDAB, 0xBDAC,
        0xBDAD, 0xBDAE, 0xBDAF, 0xBDB0, 0xBDB4, 0xBDB6, 0xBDB8, 0xBDBA,
        0xBDBB, 0xBDBC, 0xBDBD, 0xBDC3, 0xBDC4, 0xBDC5, 0xBDC6, 0xBDC7,
        0xBDC8, 0xBDCA, 0xBDCB, 0xBDCC, 0xBDCD, 0xBDCE, 0xBDCF, 0xBDD0,
        0xBDD1, 0xBDD3, 0xBDD4, 0xBDD5, 0xBDD7, 0xBDD8, 0xBDD9, 0xBDDA,
        0xBDDB, 0xBDDC, 0xBDDD, 0xBDE2, 0xBDE3, 0xBDE4, 0xBDE5, 0xBDE6,
        0xBDE7, 0xBDE8, 0xBDE9, 0xBDEA, 0xBDEB, 0xBDEC, 0xBDED, 0xBDEE,
        0xBDEF, 0xBDF0, 0xBDF1, 0xBDF3, 0xBDF4, 0xBDF5, 0xBDF7, 0xBDF8,
        0xBDF9, 0xBDFA, 0xBDFB, 0xBDFC, 0xBDFD, 0xBE42, 0xBE43, 0xBE44,
        0xBE46, 0xBE47, 0xBE48, 0xBE4A, 0xBE4B, 0xBE4C, 0xBE4D, 0xBE4E,
        0xBE4F, 0xBE50, 0xBE54, 0xBE55, 0xBE56, 0xBE57, 0xBE58, 0xBE59,
        0xBE5A, 0xBE5B, 0xBE5C, 0xBE5D, 0xBE61, 0xBE62, 0xBE63, 0xBE64,
        0xBE65, 0xBE66, 0xBE67, 0xBE68, 0xBE69, 0xBE6A, 0xBE6B, 0xBE6C,
        0xBE6D, 0xBE6E, 0xBE6F, 0xBE70, 0xBE71, 0xBE73, 0xBE74, 0xBE75,
        0xBE76, 0xBE78, 0xBE79, 0xBE7A, 0xBE7B, 0xBE7C, 0xBE7D, 0xBE83,
        0xBE84, 0xBE86, 0xBE87, 0xBE88, 0xBE8A, 0xBE8B, 0xBE8C, 0xBE8D,
        0xBE8E, 0xBE8F, 0xBE90, 0xBE94, 0xBE95, 0xBE96, 0xBE98, 0xBE99,
        0xBE9A, 0xBE9B, 0xBE9C, 0xBE9D, 0xBEA2, 0xBEA3, 0xBEA4, 0xBEA5,
        0xBEA6, 0xBEA7, 0xBEA8, 0xBEA9, 0xBEAA, 0xBEAB, 0xBEAC, 0xBEAD,
        0xBEAE, 0xBEAF, 0xBEB0, 0xBEB1, 0xBEB3, 0xBEB4, 0xBEB5, 0xBEB8,
        0xBEB9, 0xBEBA, 0xBEBB, 0xBEBC, 0xBEBD, 0xBEC1, 0xBEC2, 0xBEC3,
        0xBEC4, 0xBEC5, 0xBEC6, 0xBEC7, 0xBEC8, 0xBEC9, 0xBECA, 0xBECB,
        0xBECC, 0xBECD, 0xBECE, 0xBECF, 0xBED0, 0xBED1, 0xBED3, 0xBED4,
        0xBED5, 0xBED6, 0xBED7, 0xBED8, 0xBED9, 0xBEDA, 0xBEDB, 0xBEDC,
        0xBEDD, 0xBEE2, 0xBEE3, 0xBEE4, 0xBEE5, 0xBEE6, 0xBEE7, 0xBEE8,
        0xBEE9, 0xBEEA, 0xBEEB, 0xBEEC, 0xBEED, 0xBEEE, 0xBEEF, 0xBEF0,
        0xBEF1, 0xBEF3, 0xBEF4, 0xBEF5, 0xBEF6, 0xBEF7, 0xBEF8, 0xBEF9,
        0xBEFA, 0xBEFB, 0xBEFC, 0xBEFD, 0xBF42, 0xBF43, 0xBF44, 0xBF45,
        0xBF46, 0xBF47, 0xBF48, 0xBF49, 0xBF4A, 0xBF4B, 0xBF4C, 0xBF4D,
        0xBF4E, 0xBF4F, 0xBF50, 0xBF51, 0xBF53, 0xBF54, 0xBF55, 0xBF56,
        0xBF57, 0xBF58, 0xBF59, 0xBF5A, 0xBF5B, 0xBF5C, 0xBF5D, 0xBF62,
        0xBF63, 0xBF64, 0xBF65, 0xBF66, 0xBF67, 0xBF68, 0xBF69, 0xBF6A,
        0xBF6B, 0xBF6C, 0xBF6D, 0xBF6E, 0xBF6F, 0xBF70, 0xBF73, 0xBF74,
        0xBF76, 0xBF78, 0xBF79, 0xBF7A, 0xBF7B, 0xBF7C, 0xBF7D, 0xBF81,
        0xBF82, 0xBF83, 0xBF84, 0xBF85, 0xBF86, 0xBF87, 0xBF88, 0xBF89,
        0xBF8A, 0xBF8B, 0xBF8C, 0xBF8D, 0xBF8E, 0xBF8F, 0xBF90, 0xBF91,
        0xBF93, 0xBF94, 0xBF95, 0xBF96, 0xBF97, 0xBF98, 0xBF99, 0xBF9A,
        0xBF9B, 0xBF9C, 0xBF9D, 0xBFA3, 0xBFA4, 0xBFA6, 0xBFA7, 0xBFA8,
        0xBFAA, 0xBFAB, 0xBFAC, 0xBFAD, 0xBFAE, 0xBFAF, 0xBFB0, 0xBFB4,
        0xBFB5, 0xBFB6, 0xBFB9, 0xBFBA, 0xBFBB, 0xBFBC, 0xC063, 0xC064,
        0xC066, 0xC068, 0xC06A, 0xC06B, 0xC06C, 0xC06D, 0xC06E, 0xC06F,
        0xC070, 0xC074, 0xC079, 0xC07A, 0xC07B, 0xC07C, 0xC07D, 0xC083,
        0xC084, 0xC086, 0xC087, 0xC088, 0xC08A, 0xC08B, 0xC08C, 0xC08D,
        0xC08E, 0xC08F, 0xC090, 0xC094, 0xC098, 0xC099, 0xC09A, 0xC09B,
        0xC09C, 0xC09D, 0xC0A2, 0xC0A3, 0xC0A4, 0xC0A6, 0xC0A8, 0xC0AA,
        0xC0AB, 0xC0AC, 0xC0AD, 0xC0AE, 0xC0AF, 0xC0B0, 0xC0B3, 0xC0B4,
        0xC0B5, 0xC0B6, 0xC0B8, 0xC0B9, 0xC0BA, 0xC0BB, 0xC0BC, 0xC0BD,
        0xC0C1, 0xC0C2, 0xC0C3, 0xC0C4, 0xC0C5, 0xC0C6, 0xC0C7, 0xC0C8,
        0xC0C9, 0xC0CA, 0xC0CB, 0xC0CC, 0xC0CD, 0xC0CE, 0xC0CF, 0xC0D0,
        0xC0D1, 0xC0D3, 0xC0D4, 0xC0D5, 0xC0D6, 0xC0D7, 0xC0D8, 0xC0D9,
        0xC0DA, 0xC0DB, 0xC0DC, 0xC0DD, 0xC0E3, 0xC0E4, 0xC0E6, 0xC0E7,
        0xC0E8, 0xC0EA, 0xC0EB, 0xC0EC, 0xC0ED, 0xC0EE, 0xC0EF, 0xC0F0,
        0xC0F4, 0xC0F8, 0xC0F9, 0xC0FA, 0xC0FB, 0xC0FC, 0xC0FD, 0xC143,
        0xC144, 0xC146, 0xC147, 0xC148, 0xC14A, 0xC14B, 0xC14C, 0xC14D,
        0xC14E, 0xC14F, 0xC150, 0xC154, 0xC156, 0xC158, 0xC159, 0xC15A,
        0xC15B, 0xC15C, 0xC15D, 0xC162, 0xC163, 0xC164, 0xC166, 0xC167,
        0xC168, 0xC169, 0xC16A, 0xC16B, 0xC16C, 0xC16D, 0xC16E, 0xC16F,
        0xC170, 0xC171, 0xC173, 0xC174, 0xC175, 0xC177, 0xC178, 0xC179,
        0xC17A, 0xC17B, 0xC17C, 0xC17D, 0xC182, 0xC183, 0xC184, 0xC186,
        0xC187, 0xC188, 0xC189, 0xC18A, 0xC18B, 0xC18C, 0xC18D, 0xC18E,
        0xC18F, 0xC190, 0xC191, 0xC193, 0xC194, 0xC195, 0xC196, 0xC198,
        0xC199, 0xC19A, 0xC19B, 0xC19C, 0xC19D, 0xC1A3, 0xC1A4, 0xC1A6,
        0xC1A7, 0xC1A8, 0xC1AA, 0xC1AB, 0xC1AC, 0xC1AD, 0xC1AE, 0xC1AF,
        0xC1B0, 0xC1B4, 0xC1B6, 0xC1B8, 0xC1B9, 0xC1BA, 0xC1BB, 0xC1BC,
        0xC1BD, 0xC1C2, 0xC1C3, 0xC1C4, 0xC1C6, 0xC1C7, 0xC1C8, 0xC1CA,
        0xC1CB, 0xC1CC, 0xC1CD, 0xC1CE, 0xC1CF, 0xC1D0, 0xC1D1, 0xC1D3,
        0xC1D4, 0xC1D5, 0xC1D6, 0xC1D8, 0xC1D9, 0xC1DA, 0xC1DB, 0xC1DC,
        0xC1DD, 0xC1E1, 0xC1E2, 0xC1E3, 0xC1E4, 0xC1E5, 0xC1E6, 0xC1E7,
        0xC1E8, 0xC1E9, 0xC1EA, 0xC1EB, 0xC1EC, 0xC1ED, 0xC1EE, 0xC1EF,
        0xC1F0, 0xC1F1, 0xC1F3, 0xC1F4, 0xC1F5, 0xC1F6, 0xC1F7, 0xC1F8,
        0xC1F9, 0xC1FA, 0xC1FB, 0xC1FC, 0xC1FD, 0xC242, 0xC243, 0xC244,
        0xC246, 0xC247, 0xC248, 0xC24A, 0xC24B, 0xC24C, 0xC24D, 0xC24E,
        0xC24F, 0xC250, 0xC254, 0xC256, 0xC258, 0xC259, 0xC25A, 0xC25B,
        0xC25C, 0xC25D, 0xC262, 0xC263, 0xC264, 0xC265, 0xC266, 0xC267,
        0xC268, 0xC269, 0xC26A, 0xC26B, 0xC26C, 0xC26D, 0xC26E, 0xC26F,
        0xC270, 0xC273, 0xC274, 0xC275, 0xC276, 0xC277, 0xC278, 0xC279,
        0xC27A, 0xC27B, 0xC27C, 0xC27D, 0xC283, 0xC284, 0xC286, 0xC287,
        0xC288, 0xC28A, 0xC28B, 0xC28C, 0xC28D, 0xC28E, 0xC28F, 0xC290,
        0xC294, 0xC296, 0xC298, 0xC299, 0xC29A, 0xC29B, 0xC29C, 0xC29D,
        0xC2A2, 0xC2A3, 0xC2A4, 0xC2A5, 0xC2A6, 0xC2A7, 0xC2A8, 0xC2A9,
        0xC2AA, 0xC2AB, 0xC2AC, 0xC2AD, 0xC2AE, 0xC2AF, 0xC2B0, 0xC2B1,
        0xC2B3, 0xC2B4, 0xC2B5, 0xC2B7, 0xC2B8, 0xC2B9, 0xC2BA, 0xC2BB,
        0xC2BC, 0xC2BD, 0xC2C2, 0xC2C3, 0xC2C4, 0xC2C6, 0xC2C7, 0xC2C8,
        0xC2C9, 0xC2CA, 0xC2CB, 0xC2CC, 0xC2CD, 0xC2CE, 0xC2CF, 0xC2D0,
        0xC2D1, 0xC2D3, 0xC2D4, 0xC2D5, 0xC2D6, 0xC2D7, 0xC2D8, 0xC2D9,
        0xC2DA, 0xC2DB, 0xC2DC, 0xC2DD, 0xC2E2, 0xC2E3, 0xC2E4, 0xC2E6,
        0xC2E7, 0xC2E8, 0xC2EA, 0xC2EB, 0xC2EC, 0xC2ED, 0xC2EE, 0xC2EF,
        0xC2F0, 0xC2F4, 0xC2F6, 0xC2F8, 0xC2F9, 0xC2FA, 0xC2FB, 0xC2FC,
        0xC2FD, 0xC342, 0xC343, 0xC344, 0xC346, 0xC347, 0xC348, 0xC34A,
        0xC34B, 0xC34C, 0xC34D, 0xC34E, 0xC34F, 0xC350, 0xC353, 0xC354,
        0xC355, 0xC356, 0xC358, 0xC359, 0xC35A, 0xC35B, 0xC35C, 0xC35D,
        0xC363, 0xC364, 0xC366, 0xC367, 0xC368, 0xC36A, 0xC36B, 0xC36C,
        0xC36D, 0xC36E, 0xC36F, 0xC370, 0xC374, 0xC376, 0xC378, 0xC379,
        0xC37A, 0xC37B, 0xC37C, 0xC37D, 0xC381, 0xC382, 0xC383, 0xC384,
        0xC385, 0xC386, 0xC387, 0xC388, 0xC389, 0xC38A, 0xC38B, 0xC38C,
        0xC38D, 0xC38E, 0xC38F, 0xC390, 0xC391, 0xC393, 0xC394, 0xC395,
        0xC396, 0xC397, 0xC398, 0xC399, 0xC39A, 0xC39B, 0xC39C, 0xC39D,
        0xC3A3, 0xC3A4, 0xC3A6, 0xC3A7, 0xC3AB, 0xC3AC, 0xC3AD, 0xC3AE,
        0xC3AF, 0xC3B0, 0xC3B4, 0xC3B6, 0xC3B8, 0xC3B9, 0xC3BA, 0xC3BB,
        0xC3BC, 0xC3BD, 0xC463, 0xC464, 0xC466, 0xC467, 0xC468, 0xC46A,
        0xC46B, 0xC46C, 0xC46D, 0xC46E, 0xC46F, 0xC470, 0xC474, 0xC476,
        0xC478, 0xC479, 0xC47A, 0xC47B, 0xC47C, 0xC47D, 0xC483, 0xC484,
        0xC486, 0xC487, 0xC488, 0xC48A, 0xC48B, 0xC48C, 0xC48D, 0xC48E,
        0xC48F, 0xC490, 0xC494, 0xC498, 0xC499, 0xC49A, 0xC49B, 0xC49C,
        0xC49D, 0xC4A3, 0xC4A4, 0xC4A5, 0xC4A6, 0xC4A7, 0xC4A8, 0xC4A9,
        0xC4AA, 0xC4AB, 0xC4AC, 0xC4AD, 0xC4AE, 0xC4AF, 0xC4B0, 0xC4B1,
        0xC4B3, 0xC4B4, 0xC4B5, 0xC4B6, 0xC4B8, 0xC4B9, 0xC4BA, 0xC4BB,
        0xC4BC, 0xC4BD, 0xC4C1, 0xC4C2, 0xC4C3, 0xC4C4, 0xC4C5, 0xC4C6,
        0xC4C7, 0xC4C8, 0xC4C9, 0xC4CA, 0xC4CB, 0xC4CC, 0xC4CD, 0xC4CE,
        0xC4CF, 0xC4D0, 0xC4D1, 0xC4D3, 0xC4D4, 0xC4D5, 0xC4D6, 0xC4D7,
        0xC4D8, 0xC4D9, 0xC4DA, 0xC4DB, 0xC4DC, 0xC4DD, 0xC4E3, 0xC4E4,
        0xC4E6, 0xC4E7, 0xC4EA, 0xC4EB, 0xC4EC, 0xC4ED, 0xC4EE, 0xC4EF,
        0xC4F0, 0xC4F4, 0xC4F8, 0xC4F9, 0xC4FA, 0xC4FB, 0xC4FC, 0xC4FD,
        0xC543, 0xC544, 0xC546, 0xC547, 0xC548, 0xC54A, 0xC54B, 0xC54C,
        0xC54D, 0xC54E, 0xC54F, 0xC550, 0xC554, 0xC556, 0xC558, 0xC559,
        0xC55A, 0xC55B, 0xC55C, 0xC55D, 0xC562, 0xC563, 0xC564, 0xC566,
        0xC567, 0xC568, 0xC56A, 0xC56B, 0xC56C, 0xC56D, 0xC56E, 0xC56F,
        0xC570, 0xC574, 0xC578, 0xC579, 0xC57A, 0xC57B, 0xC57C, 0xC57D,
        0xC582, 0xC583, 0xC584, 0xC585, 0xC586, 0xC587, 0xC588, 0xC589,
        0xC58A, 0xC58B, 0xC58C, 0xC58D, 0xC58E, 0xC58F, 0xC590, 0xC591,
        0xC593, 0xC594, 0xC595, 0xC596, 0xC597, 0xC598, 0xC599, 0xC59A,
        0xC59B, 0xC59C, 0xC59D, 0xC5A3, 0xC5A4, 0xC5A6, 0xC5A7, 0xC5A8,
        0xC5AA, 0xC5AB, 0xC5AC, 0xC5AD, 0xC5AE, 0xC5AF, 0xC5B0, 0xC5B4,
        0xC5B6, 0xC5B8, 0xC5B9, 0xC5BA, 0xC5BB, 0xC5BC, 0xC5BD, 0xC5C3,
        0xC5C4, 0xC5C6, 0xC5C7, 0xC5C8, 0xC5CA, 0xC5CB, 0xC5CC, 0xC5CD,
        0xC5CE, 0xC5CF, 0xC5D0, 0xC5D3, 0xC5D4, 0xC5D5, 0xC5D6, 0xC5D8,
        0xC5D9, 0xC5DA, 0xC5DB, 0xC5DC, 0xC5DD, 0xC5E2, 0xC5E3, 0xC5E4,
        0xC5E5, 0xC5E6, 0xC5E7, 0xC5E8, 0xC5E9, 0xC5EA, 0xC5EB, 0xC5EC,
        0xC5ED, 0xC5EE, 0xC5EF, 0xC5F0, 0xC5F1, 0xC5F3, 0xC5F4, 0xC5F5,
        0xC5F6, 0xC5F8, 0xC5F9, 0xC5FA, 0xC5FB, 0xC5FC, 0xC5FD, 0xC642,
        0xC643, 0xC644, 0xC645, 0xC646, 0xC647, 0xC648, 0xC64A, 0xC64B,
        0xC64C, 0xC64D, 0xC64E, 0xC64F, 0xC650, 0xC651, 0xC653, 0xC654,
        0xC655, 0xC656, 0xC657, 0xC658, 0xC659, 0xC65A, 0xC65B, 0xC65C,
        0xC65D, 0xC662, 0xC663, 0xC664, 0xC665, 0xC666, 0xC667, 0xC668,
        0xC669, 0xC66A, 0xC66B, 0xC66C, 0xC66D, 0xC66E, 0xC66F, 0xC670,
        0xC671, 0xC673, 0xC674, 0xC675, 0xC676, 0xC677, 0xC678, 0xC679,
        0xC67A, 0xC67B, 0xC67C, 0xC67D, 0xC683, 0xC684, 0xC686, 0xC687,
        0xC688, 0xC68A, 0xC68B, 0xC68C, 0xC68D, 0xC68E, 0xC68F, 0xC690,
        0xC694, 0xC696, 0xC698, 0xC699, 0xC69A, 0xC69B, 0xC69C, 0xC69D,
        0xC6A2, 0xC6A3, 0xC6A4, 0xC6A6, 0xC6A7, 0xC6A8, 0xC6AA, 0xC6AB,
        0xC6AC, 0xC6AD, 0xC6AE, 0xC6AF, 0xC6B0, 0xC6B1, 0xC6B3, 0xC6B4,
        0xC6B5, 0xC6B6, 0xC6B8, 0xC6B9, 0xC6BA, 0xC6BB, 0xC6BC, 0xC6BD,
        0xC6C2, 0xC6C3, 0xC6C4, 0xC6C5, 0xC6C6, 0xC6C7, 0xC6C8, 0xC6C9,
        0xC6CA, 0xC6CB, 0xC6CC, 0xC6CD, 0xC6CE, 0xC6CF, 0xC6D0, 0xC6D1,
        0xC6D3, 0xC6D4, 0xC6D5, 0xC6D6, 0xC6D8, 0xC6D9, 0xC6DA, 0xC6DB,
        0xC6DC, 0xC6DD, 0xC6E3, 0xC6E4, 0xC6E6, 0xC6E7, 0xC6E8, 0xC6EA,
        0xC6EB, 0xC6EC, 0xC6ED, 0xC6EE, 0xC6EF, 0xC6F0, 0xC6F4, 0xC6F6,
        0xC6F8, 0xC6F9, 0xC6FA, 0xC6FB, 0xC6FC, 0xC6FD, 0xC742, 0xC743,
        0xC744, 0xC746, 0xC747, 0xC748, 0xC74A, 0xC74B, 0xC74C, 0xC74D,
        0xC74E, 0xC74F, 0xC750, 0xC753, 0xC754, 0xC755, 0xC756, 0xC757,
        0xC758, 0xC759, 0xC75A, 0xC75B, 0xC75C, 0xC75D, 0xC763, 0xC764,
        0xC766, 0xC767, 0xC768, 0xC76A, 0xC76B, 0xC76C, 0xC76D, 0xC76E,
        0xC76F, 0xC770, 0xC774, 0xC775, 0xC776, 0xC778, 0xC779, 0xC77A,
        0xC77B, 0xC77C, 0xC77D, 0xC781, 0xC782, 0xC783, 0xC784, 0xC785,
        0xC786, 0xC787, 0xC788, 0xC789, 0xC78A, 0xC78B, 0xC78C, 0xC78D,
        0xC78E, 0xC78F, 0xC790, 0xC791, 0xC793, 0xC794, 0xC795, 0xC796,
        0xC797, 0xC798, 0xC799, 0xC79A, 0xC79B, 0xC79C, 0xC79D, 0xC7A3,
        0xC7A4, 0xC7A6, 0xC7A7, 0xC7A8, 0xC7AA, 0xC7AB, 0xC7AC, 0xC7AD,
        0xC7AE, 0xC7AF, 0xC7B0, 0xC7B4, 0xC7B6, 0xC7B8, 0xC7B9, 0xC7BA,
        0xC7BB, 0xC7BC, 0xC7BD, 0xC863, 0xC864, 0xC866, 0xC867, 0xC868,
        0xC86B, 0xC86C, 0xC86D, 0xC86E, 0xC86F, 0xC870, 0xC874, 0xC878,
        0xC879, 0xC87A, 0xC87B, 0xC87C, 0xC87D, 0xC883, 0xC884, 0xC886,
        0xC887, 0xC888, 0xC88A, 0xC88B, 0xC88C, 0xC88D, 0xC88E, 0xC88F,
        0xC890, 0xC894, 0xC898, 0xC899, 0xC89A, 0xC89B, 0xC89C, 0xC89D,
        0xC8A2, 0xC8A3, 0xC8A4, 0xC8A5, 0xC8A6, 0xC8A7, 0xC8A8, 0xC8A9,
        0xC8AA, 0xC8AB, 0xC8AC, 0xC8AD, 0xC8AE, 0xC8AF, 0xC8B0, 0xC8B1,
        0xC8B3, 0xC8B4, 0xC8B5, 0xC8B6, 0xC8B8, 0xC8B9, 0xC8BA, 0xC8BB,
        0xC8BC, 0xC8BD, 0xC8C1, 0xC8C2, 0xC8C3, 0xC8C4, 0xC8C5, 0xC8C6,
        0xC8C7, 0xC8C8, 0xC8C9, 0xC8CA, 0xC8CB, 0xC8CC, 0xC8CD, 0xC8CE,
        0xC8CF, 0xC8D0, 0xC8D1, 0xC8D3, 0xC8D4, 0xC8D5, 0xC8D6, 0xC8D7,
        0xC8D8, 0xC8D9, 0xC8DA, 0xC8DB, 0xC8DC, 0xC8DD, 0xC8E3, 0xC8E4,
        0xC8E6, 0xC8E7, 0xC8E8, 0xC8EA, 0xC8EC, 0xC8ED, 0xC8EE, 0xC8EF,
        0xC8F0, 0xC8F4, 0xC8F8, 0xC8F9, 0xC8FA, 0xC8FB, 0xC8FC, 0xC8FD,
        0xC943, 0xC944, 0xC946, 0xC947, 0xC948, 0xC94A, 0xC94B, 0xC94C,
        0xC94D, 0xC94E, 0xC94F, 0xC950, 0xC954, 0xC956, 0xC958, 0xC959,
        0xC95A, 0xC95B, 0xC95C, 0xC95D, 0xC962, 0xC963, 0xC964, 0xC966,
        0xC967, 0xC968, 0xC969, 0xC96A, 0xC96B, 0xC96C, 0xC96D, 0xC96E,
        0xC96F, 0xC970, 0xC971, 0xC973, 0xC974, 0xC975, 0xC977, 0xC978,
        0xC979, 0xC97A, 0xC97B, 0xC97C, 0xC97D, 0xC982, 0xC983, 0xC984,
        0xC986, 0xC987, 0xC988, 0xC989, 0xC98A, 0xC98B, 0xC98C, 0xC98D,
        0xC98E, 0xC98F, 0xC990, 0xC991, 0xC993, 0xC994, 0xC995, 0xC996,
        0xC997, 0xC998, 0xC999, 0xC99A, 0xC99B, 0xC99C, 0xC99D, 0xC9A3,
        0xC9A4, 0xC9A6, 0xC9A7, 0xC9A8, 0xC9AA, 0xC9AB, 0xC9AC, 0xC9AD,
        0xC9AE, 0xC9AF, 0xC9B0, 0xC9B4, 0xC9B6, 0xC9B8, 0xC9B9, 0xC9BA,
        0xC9BB, 0xC9BD, 0xC9C2, 0xC9C3, 0xC9C4, 0xC9C6, 0xC9C7, 0xC9C8,
        0xC9C9, 0xC9CA, 0xC9CB, 0xC9CC, 0xC9CD, 0xC9CE, 0xC9CF, 0xC9D0,
        0xC9D1, 0xC9D3, 0xC9D4, 0xC9D5, 0xC9D6, 0xC9D7, 0xC9D8, 0xC9D9,
        0xC9DA, 0xC9DB, 0xC9DC, 0xC9DD, 0xC9E2, 0xC9E3, 0xC9E4, 0xC9E5,
        0xC9E6, 0xC9E7, 0xC9E8, 0xC9E9, 0xC9EA, 0xC9EB, 0xC9EC, 0xC9ED,
        0xC9EE, 0xC9EF, 0xC9F0, 0xC9F1, 0xC9F3, 0xC9F4, 0xC9F5, 0xC9F6,
        0xC9F7, 0xC9F8, 0xC9F9, 0xC9FA, 0xC9FB, 0xC9FC, 0xC9FD, 0xCA42,
        0xCA43, 0xCA44, 0xCA46, 0xCA47, 0xCA48, 0xCA49, 0xCA4A, 0xCA4B,
        0xCA4C, 0xCA4D, 0xCA4E, 0xCA4F, 0xCA50, 0xCA51, 0xCA53, 0xCA54,
        0xCA56, 0xCA58, 0xCA59, 0xCA5A, 0xCA5B, 0xCA5C, 0xCA5D, 0xCA62,
        0xCA63, 0xCA64, 0xCA65, 0xCA66, 0xCA67, 0xCA68, 0xCA69, 0xCA6A,
        0xCA6B, 0xCA6C, 0xCA6D, 0xCA6E, 0xCA6F, 0xCA70, 0xCA71, 0xCA73,
        0xCA74, 0xCA75, 0xCA76, 0xCA77, 0xCA78, 0xCA79, 0xCA7A, 0xCA7B,
        0xCA7C, 0xCA7D, 0xCA83, 0xCA84, 0xCA86, 0xCA87, 0xCA88, 0xCA8A,
        0xCA8B, 0xCA8C, 0xCA8D, 0xCA8E, 0xCA8F, 0xCA90, 0xCA94, 0xCA96,
        0xCA98, 0xCA99, 0xCA9A, 0xCA9B, 0xCA9C, 0xCA9D, 0xCAA2, 0xCAA3,
        0xCAA4, 0xCAA5, 0xCAA6, 0xCAA7, 0xCAA8, 0xCAA9, 0xCAAA, 0xCAAB,
        0xCAAC, 0xCAAD, 0xCAAE, 0xCAAF, 0xCAB0, 0xCAB1, 0xCAB3, 0xCAB4,
        0xCAB5, 0xCAB7, 0xCAB8, 0xCAB9, 0xCABA, 0xCABB, 0xCABC, 0xCABD,
        0xCAC2, 0xCAC3, 0xCAC4, 0xCAC5, 0xCAC6, 0xCAC7, 0xCAC8, 0xCAC9,
        0xCACA, 0xCACB, 0xCACC, 0xCACD, 0xCACE, 0xCACF, 0xCAD0, 0xCAD1,
        0xCAD3, 0xCAD4, 0xCAD5, 0xCAD6, 0xCAD7, 0xCAD8, 0xCAD9, 0xCADA,
        0xCADB, 0xCADC, 0xCADD, 0xCAE3, 0xCAE4, 0xCAE6, 0xCAE7, 0xCAE8,
        0xCAEA, 0xCAEB, 0xCAEC, 0xCAED, 0xCAEE, 0xCAEF, 0xCAF0, 0xCAF4,
        0xCAF5, 0xCAF6, 0xCAF8, 0xCAF9, 0xCAFA, 0xCAFB, 0xCAFC, 0xCAFD,
        0xCB42, 0xCB43, 0xCB44, 0xCB46, 0xCB47, 0xCB48, 0xCB4A, 0xCB4B,
        0xCB4C, 0xCB4D, 0xCB4E, 0xCB4F, 0xCB50, 0xCB53, 0xCB54, 0xCB55,
        0xCB56, 0xCB58, 0xCB59, 0xCB5A, 0xCB5B, 0xCB5C, 0xCB5D, 0xCB63,
        0xCB64, 0xCB66, 0xCB67, 0xCB6A, 0xCB6C, 0xCB6D, 0xCB6E, 0xCB6F,
        0xCB70, 0xCB74, 0xCB76, 0xCB77, 0xCB78, 0xCB79, 0xCB7A, 0xCB7B,
        0xCB7C, 0xCB7D, 0xCB82, 0xCB83, 0xCB84, 0xCB86, 0xCB87, 0xCB88,
        0xCB8A, 0xCB8B, 0xCB8C, 0xCB8D, 0xCB8E, 0xCB8F, 0xCB90, 0xCB94,
        0xCB95, 0xCB96, 0xCB97, 0xCB98, 0xCB99, 0xCB9A, 0xCB9B, 0xCB9C,
        0xCB9D, 0xCBA3, 0xCBA4, 0xCBA6, 0xCBA7, 0xCBA8, 0xCBAA, 0xCBAB,
        0xCBAC, 0xCBAD, 0xCBAE, 0xCBAF, 0xCBB0, 0xCBB4, 0xCBB6, 0xCBB8,
        0xCBB9, 0xCBBA, 0xCBBB, 0xCBBC, 0xCBBD, 0xCC64, 0xCC66, 0xCC67,
        0xCC68, 0xCC6A, 0xCC6C, 0xCC6D, 0xCC6E, 0xCC6F, 0xCC70, 0xCC74,
        0xCC78, 0xCC79, 0xCC7A, 0xCC7C, 0xCC7D, 0xCC83, 0xCC84, 0xCC86,
        0xCC87, 0xCC88, 0xCC8A, 0xCC8B, 0xCC8C, 0xCC8D, 0xCC8E, 0xCC8F,
        0xCC90, 0xCC94, 0xCC98, 0xCC99, 0xCC9A, 0xCC9B, 0xCC9C, 0xCC9D,
        0xCCA3, 0xCCA4, 0xCCA5, 0xCCA6, 0xCCA7, 0xCCA8, 0xCCA9, 0xCCAA,
        0xCCAB, 0xCCAC, 0xCCAD, 0xCCAE, 0xCCAF, 0xCCB0, 0xCCB1, 0xCCB3,
        0xCCB4, 0xCCB5, 0xCCB6, 0xCCB7, 0xCCB8, 0xCCB9, 0xCCBA, 0xCCBB,
        0xCCBC, 0xCCBD, 0xCCC1, 0xCCC2, 0xCCC3, 0xCCC4, 0xCCC5, 0xCCC6,
        0xCCC7, 0xCCC8, 0xCCC9, 0xCCCA, 0xCCCB, 0xCCCC, 0xCCCD, 0xCCCE,
        0xCCCF, 0xCCD0, 0xCCD1, 0xCCD3, 0xCCD4, 0xCCD5, 0xCCD6, 0xCCD7,
        0xCCD8, 0xCCD9, 0xCCDA, 0xCCDB, 0xCCDC, 0xCCDD, 0xCCE3, 0xCCE4,
        0xCCE6, 0xCCE7, 0xCCE8, 0xCCEA, 0xCCEB, 0xCCEC, 0xCCED, 0xCCEE,
        0xCCEF, 0xCCF0, 0xCCF4, 0xCCF8, 0xCCF9, 0xCCFA, 0xCCFB, 0xCCFC,
        0xCCFD, 0xCD43, 0xCD44, 0xCD46, 0xCD47, 0xCD48, 0xCD4A, 0xCD4B,
        0xCD4C, 0xCD4D, 0xCD4E, 0xCD4F, 0xCD50, 0xCD54, 0xCD56, 0xCD58,
        0xCD59, 0xCD5A, 0xCD5B, 0xCD5C, 0xCD5D, 0xCD62, 0xCD63, 0xCD64,
        0xCD66, 0xCD67, 0xCD68, 0xCD6A, 0xCD6B, 0xCD6C, 0xCD6D, 0xCD6E,
        0xCD6F, 0xCD70, 0xCD74, 0xCD75, 0xCD78, 0xCD79, 0xCD7A, 0xCD7B,
        0xCD7C, 0xCD7D, 0xCD82, 0xCD83, 0xCD84, 0xCD85, 0xCD86, 0xCD87,
        0xCD88, 0xCD8A, 0xCD8B, 0xCD8C, 0xCD8D, 0xCD8E, 0xCD8F, 0xCD90,
        0xCD91, 0xCD94, 0xCD96, 0xCD97, 0xCD98, 0xCD99, 0xCD9A, 0xCD9B,
        0xCD9C, 0xCD9D, 0xCDA3, 0xCDA4, 0xCDA6, 0xCDA7, 0xCDA8, 0xCDAA,
        0xCDAB, 0xCDAC, 0xCDAD, 0xCDAE, 0xCDAF, 0xCDB0, 0xCDB4, 0xCDB6,
        0xCDB8, 0xCDB9, 0xCDBA, 0xCDBB, 0xCDBC, 0xCDBD, 0xCDC2, 0xCDC3,
        0xCDC4, 0xCDC5, 0xCDC6, 0xCDC7, 0xCDC8, 0xCDC9, 0xCDCA, 0xCDCB,
        0xCDCC, 0xCDCD, 0xCDCE, 0xCDCF, 0xCDD0, 0xCDD1, 0xCDD3, 0xCDD4,
        0xCDD5, 0xCDD6, 0xCDD8, 0xCDD9, 0xCDDA, 0xCDDB, 0xCDDC, 0xCDDD,
        0xCDE1, 0xCDE2, 0xCDE3, 0xCDE4, 0xCDE5, 0xCDE6, 0xCDE7, 0xCDE8,
        0xCDE9, 0xCDEA, 0xCDEB, 0xCDEC, 0xCDED, 0xCDEE, 0xCDEF, 0xCDF0,
        0xCDF1, 0xCDF3, 0xCDF4, 0xCDF5, 0xCDF6, 0xCDF7, 0xCDF8, 0xCDF9,
        0xCDFA, 0xCDFB, 0xCDFC, 0xCDFD, 0xCE42, 0xCE43, 0xCE44, 0xCE46,
        0xCE47, 0xCE48, 0xCE49, 0xCE4A, 0xCE4B, 0xCE4C, 0xCE4D, 0xCE4E,
        0xCE4F, 0xCE50, 0xCE51, 0xCE53, 0xCE54, 0xCE55, 0xCE56, 0xCE57,
        0xCE58, 0xCE59, 0xCE5A, 0xCE5B, 0xCE5C, 0xCE5D, 0xCE62, 0xCE63,
        0xCE64, 0xCE66, 0xCE67, 0xCE68, 0xCE6A, 0xCE6B, 0xCE6C, 0xCE6D,
        0xCE6E, 0xCE6F, 0xCE70, 0xCE71, 0xCE74, 0xCE76, 0xCE77, 0xCE78,
        0xCE79, 0xCE7A, 0xCE7B, 0xCE7C, 0xCE7D, 0xCE83, 0xCE84, 0xCE86,
        0xCE87, 0xCE8A, 0xCE8C, 0xCE8D, 0xCE8E, 0xCE8F, 0xCE90, 0xCE94,
        0xCE96, 0xCE98, 0xCE99, 0xCE9A, 0xCE9B, 0xCE9C, 0xCE9D, 0xCEA2,
        0xCEA3, 0xCEA4, 0xCEA5, 0xCEA6, 0xCEA7, 0xCEA8, 0xCEA9, 0xCEAA,
        0xCEAB, 0xCEAC, 0xCEAD, 0xCEAE, 0xCEAF, 0xCEB0, 0xCEB1, 0xCEB3,
        0xCEB4, 0xCEB5, 0xCEB6, 0xCEB8, 0xCEB9, 0xCEBA, 0xCEBB, 0xCEBC,
        0xCEBD, 0xCEC1, 0xCEC2, 0xCEC3, 0xCEC4, 0xCEC5, 0xCEC6, 0xCEC7,
        0xCEC8, 0xCEC9, 0xCECA, 0xCECB, 0xCECC, 0xCECD, 0xCECE, 0xCECF,
        0xCED0, 0xCED1, 0xCED3, 0xCED4, 0xCED5, 0xCED6, 0xCED7, 0xCED8,
        0xCED9, 0xCEDA, 0xCEDB, 0xCEDC, 0xCEDD, 0xCEE2, 0xCEE3, 0xCEE4,
        0xCEE6, 0xCEE7, 0xCEE8, 0xCEEA, 0xCEEB, 0xCEEC, 0xCEED, 0xCEEE,
        0xCEEF, 0xCEF0, 0xCEF3, 0xCEF4, 0xCEF6, 0xCEF7, 0xCEF8, 0xCEF9,
        0xCEFA, 0xCEFB, 0xCEFC, 0xCEFD, 0xCF42, 0xCF43, 0xCF44, 0xCF46,
        0xCF47, 0xCF48, 0xCF4A, 0xCF4B, 0xCF4C, 0xCF4D, 0xCF4E, 0xCF4F,
        0xCF50, 0xCF53, 0xCF54, 0xCF56, 0xCF58, 0xCF59, 0xCF5A, 0xCF5B,
        0xCF5C, 0xCF5D, 0xCF62, 0xCF63, 0xCF64, 0xCF66, 0xCF67, 0xCF68,
        0xCF6A, 0xCF6B, 0xCF6C, 0xCF6D, 0xCF6E, 0xCF6F, 0xCF70, 0xCF74,
        0xCF76, 0xCF77, 0xCF78, 0xCF79, 0xCF7A, 0xCF7B, 0xCF7C, 0xCF7D,
        0xCF81, 0xCF82, 0xCF83, 0xCF84, 0xCF85, 0xCF86, 0xCF87, 0xCF88,
        0xCF89, 0xCF8A, 0xCF8B, 0xCF8C, 0xCF8D, 0xCF8E, 0xCF8F, 0xCF90,
        0xCF91, 0xCF93, 0xCF94, 0xCF95, 0xCF96, 0xCF97, 0xCF98, 0xCF99,
        0xCF9A, 0xCF9B, 0xCF9C, 0xCF9D, 0xCFA3, 0xCFA4, 0xCFA6, 0xCFA7,
        0xCFA8, 0xCFAA, 0xCFAB, 0xCFAC, 0xCFAD, 0xCFAE, 0xCFAF, 0xCFB0,
        0xCFB4, 0xCFB6, 0xCFB8, 0xCFB9, 0xCFBA, 0xCFBB, 0xCFBC, 0xCFBD,
        0xD063, 0xD064, 0xD066, 0xD067, 0xD068, 0xD06A, 0xD06B, 0xD06C,
        0xD06D, 0xD06F, 0xD070, 0xD074, 0xD076, 0xD078, 0xD079, 0xD07A,
        0xD07B, 0xD07C, 0xD07D, 0xD083, 0xD084, 0xD086, 0xD087, 0xD088,
        0xD08A, 0xD08B, 0xD08C, 0xD08D, 0xD08E, 0xD08F, 0xD090, 0xD094,
        0xD098, 0xD099, 0xD09A, 0xD09B, 0xD09C, 0xD09D, 0xD0A2, 0xD0A3,
        0xD0A4, 0xD0A5, 0xD0A6, 0xD0A7, 0xD0A8, 0xD0A9, 0xD0AA, 0xD0AB,
        0xD0AC, 0xD0AD, 0xD0AE, 0xD0AF, 0xD0B0, 0xD0B1, 0xD0B3, 0xD0B4,
        0xD0B5, 0xD0B6, 0xD0B8, 0xD0B9, 0xD0BA, 0xD0BB, 0xD0BC, 0xD0BD,
        0xD0C1, 0xD0C2, 0xD0C3, 0xD0C4, 0xD0C5, 0xD0C6, 0xD0C7, 0xD0C8,
        0xD0C9, 0xD0CA, 0xD0CB, 0xD0CC, 0xD0CD, 0xD0CE, 0xD0CF, 0xD0D0,
        0xD0D1, 0xD0D3, 0xD0D4, 0xD0D5, 0xD0D6, 0xD0D7, 0xD0D8, 0xD0D9,
        0xD0DA, 0xD0DB, 0xD0DC, 0xD0DD, 0xD0E3, 0xD0E4, 0xD0E6, 0xD0E7,
        0xD0E8, 0xD0EA, 0xD0EC, 0xD0ED, 0xD0EE, 0xD0EF, 0xD0F0, 0xD0F4,
        0xD0F6, 0xD0F8, 0xD0F9, 0xD0FA, 0xD0FB, 0xD0FC, 0xD0FD, 0xD143,
        0xD144, 0xD146, 0xD147, 0xD148, 0xD14A, 0xD14B, 0xD14C, 0xD14D,
        0xD14E, 0xD14F, 0xD150, 0xD154, 0xD156, 0xD158, 0xD159, 0xD15A,
        0xD15B, 0xD15C, 0xD15D, 0xD163, 0xD164, 0xD166, 0xD167, 0xD168,
        0xD16A, 0xD16B, 0xD16C, 0xD16D, 0xD16E, 0xD16F, 0xD170, 0xD174,
        0xD178, 0xD179, 0xD17A, 0xD17B, 0xD17C, 0xD17D, 0xD182, 0xD183,
        0xD184, 0xD186, 0xD187, 0xD188, 0xD18A, 0xD18B, 0xD18C, 0xD18D,
        0xD18E, 0xD18F, 0xD190, 0xD191, 0xD194, 0xD195, 0xD196, 0xD197,
        0xD198, 0xD199, 0xD19A, 0xD19B, 0xD19C, 0xD19D, 0xD1A3, 0xD1A4,
        0xD1A6, 0xD1A7, 0xD1A8, 0xD1AA, 0xD1AB, 0xD1AC, 0xD1AD, 0xD1AF,
        0xD1B0, 0xD1B4, 0xD1B6, 0xD1B8, 0xD1B9, 0xD1BA, 0xD1BC, 0xD1BD,
        0xD1C3, 0xD1C4, 0xD1C6, 0xD1C7, 0xD1C8, 0xD1CA, 0xD1CB, 0xD1CC,
        0xD1CD, 0xD1CE, 0xD1CF, 0xD1D0, 0xD1D1, 0xD1D3, 0xD1D4, 0xD1D6,
        0xD1D8, 0xD1D9, 0xD1DA, 0xD1DB, 0xD1DC, 0xD1DD, 0xD1E3, 0xD1E4,
        0xD1E6, 0xD1E7, 0xD1E8, 0xD1E9, 0xD1EA, 0xD1EB, 0xD1EC, 0xD1ED,
        0xD1EE, 0xD1EF, 0xD1F0, 0xD1F1, 0xD1F3, 0xD1F4, 0xD1F6, 0xD1F8,
        0xD1F9, 0xD1FA, 0xD1FB, 0xD1FC, 0xD1FD, 0xD243, 0xD244, 0xD246,
        0xD247, 0xD248, 0xD24A, 0xD24B, 0xD24C, 0xD24D, 0xD24E, 0xD24F,
        0xD250, 0xD251, 0xD254, 0xD256, 0xD258, 0xD259, 0xD25A, 0xD25B,
        0xD25C, 0xD25D, 0xD262, 0xD263, 0xD264, 0xD266, 0xD267, 0xD268,
        0xD26A, 0xD26B, 0xD26C, 0xD26D, 0xD26E, 0xD26F, 0xD270, 0xD271,
        0xD274, 0xD276, 0xD277, 0xD278, 0xD279, 0xD27A, 0xD27B, 0xD27C,
        0xD27D, 0xD283, 0xD284, 0xD286, 0xD287, 0xD288, 0xD28A, 0xD28B,
        0xD28C, 0xD28D, 0xD28F, 0xD290, 0xD293, 0xD294, 0xD296, 0xD298,
        0xD299, 0xD29A, 0xD29B, 0xD29C, 0xD29D, 0xD2A2, 0xD2A3, 0xD2A4,
        0xD2A6, 0xD2A7, 0xD2A8, 0xD2AA, 0xD2AB, 0xD2AC, 0xD2AD, 0xD2AE,
        0xD2AF, 0xD2B0, 0xD2B3, 0xD2B4, 0xD2B5, 0xD2B6, 0xD2B8, 0xD2B9,
        0xD2BA, 0xD2BB, 0xD2BC, 0xD2BD, 0xD2C3, 0xD2C4, 0xD2C6, 0xD2C7,
        0xD2C8, 0xD2CA, 0xD2CB, 0xD2CC, 0xD2CD, 0xD2CE, 0xD2CF, 0xD2D0,
        0xD2D1, 0xD2D3, 0xD2D4, 0xD2D5, 0xD2D6, 0xD2D8, 0xD2D9, 0xD2DA,
        0xD2DB, 0xD2DC, 0xD2DD, 0xD2E3, 0xD2E4, 0xD2E6, 0xD2E7, 0xD2E8,
        0xD2EA, 0xD2EB, 0xD2EC, 0xD2ED, 0xD2EE, 0xD2EF, 0xD2F0, 0xD2F4,
        0xD2F6, 0xD2F8, 0xD2F9, 0xD2FA, 0xD2FB, 0xD2FC, 0xD2FD, 0xD343,
        0xD344, 0xD346, 0xD347, 0xD348, 0xD34A, 0xD34B, 0xD34C, 0xD34D,
        0xD34E, 0xD34F, 0xD350, 0xD353, 0xD354, 0xD356, 0xD358, 0xD359,
        0xD35A, 0xD35B, 0xD35C, 0xD35D, 0xD363, 0xD364, 0xD366, 0xD36B,
        0xD36C, 0xD36D, 0xD36E, 0xD36F, 0xD370, 0xD374, 0xD376, 0xD378,
        0xD379, 0xD37A, 0xD37C, 0xD37D, 0xD382, 0xD383, 0xD384, 0xD386,
        0xD387, 0xD388, 0xD38A, 0xD38B, 0xD38C, 0xD38D, 0xD38E, 0xD38F,
        0xD390, 0xD394, 0xD395, 0xD396, 0xD398, 0xD399, 0xD39A, 0xD39B,
        0xD39C, 0xD39D, 0xD3A3, 0xD3A4, 0xD3A6, 0xD3A7, 0xD3A8, 0xD3AA,
        0xD3AB, 0xD3AC, 0xD3AD, 0xD3AE, 0xD3AF, 0xD3B0, 0xD3B4, 0xD3B6,
        0xD3B8, 0xD3B9, 0xD3BA, 0xD3BB, 0xD3BC, 0xD3BD, 
#endif   // __GLAN_EXTEND_KS
        
        0x8861, 0x8862,
        0x8865, 0x8868, 0x8869, 0x886A, 0x886B, 0x8871, 0x8873, 0x8874,
        0x8875, 0x8876, 0x8877, 0x8878, 0x8879, 0x887B, 0x887C, 0x887D,
        0x8881, 0x8882, 0x8885, 0x8889, 0x8891, 0x8893, 0x8895, 0x8896,
        0x8897, 0x88A1, 0x88A2, 0x88A5, 0x88A9, 0x88B5, 0x88B7, 0x88C1,
        0x88C5, 0x88C9, 0x88E1, 0x88E2, 0x88E5, 0x88E8, 0x88E9, 0x88EB,
        0x88F1, 0x88F3, 0x88F5, 0x88F6, 0x88F7, 0x88F8, 0x88FB, 0x88FC,
        0x88FD, 0x8941, 0x8945, 0x8949, 0x8951, 0x8953, 0x8955, 0x8956,
        0x8957, 0x8961, 0x8962, 0x8963, 0x8965, 0x8968, 0x8969, 0x8971,
        0x8973, 0x8975, 0x8976, 0x8977, 0x897B, 0x8981, 0x8985, 0x8989,
        0x8993, 0x8995, 0x89A1, 0x89A2, 0x89A5, 0x89A8, 0x89A9, 0x89AB,
        0x89AD, 0x89B0, 0x89B1, 0x89B3, 0x89B5, 0x89B7, 0x89B8, 0x89C1,
        0x89C2, 0x89C5, 0x89C9, 0x89CB, 0x89D1, 0x89D3, 0x89D5, 0x89D7,
        0x89E1, 0x89E5, 0x89E9, 0x89F1, 0x89F6, 0x89F7, 0x8A41, 0x8A42,
        0x8A45, 0x8A49, 0x8A51, 0x8A53, 0x8A55, 0x8A57, 0x8A61, 0x8A65,
        0x8A69, 0x8A73, 0x8A75, 0x8A81, 0x8A82, 0x8A85, 0x8A88, 0x8A89,
        0x8A8A, 0x8A8B, 0x8A90, 0x8A91, 0x8A93, 0x8A95, 0x8A97, 0x8A98,
        0x8AA1, 0x8AA2, 0x8AA5, 0x8AA9, 0x8AB6, 0x8AB7, 0x8AC1, 0x8AD5,
        0x8AE1, 0x8AE2, 0x8AE5, 0x8AE9, 0x8AF1, 0x8AF3, 0x8AF5, 0x8B41,
        0x8B45, 0x8B49, 0x8B61, 0x8B62, 0x8B65, 0x8B68, 0x8B69, 0x8B6A,
        0x8B71, 0x8B73, 0x8B75, 0x8B77, 0x8B81, 0x8BA1, 0x8BA2, 0x8BA5,
        0x8BA8, 0x8BA9, 0x8BAB, 0x8BB1, 0x8BB3, 0x8BB5, 0x8BB7, 0x8BB8,
        0x8BBC, 0x8C61, 0x8C62, 0x8C63, 0x8C65, 0x8C69, 0x8C6B, 0x8C71,
        0x8C73, 0x8C75, 0x8C76, 0x8C77, 0x8C7B, 0x8C81, 0x8C82, 0x8C85,
        0x8C89, 0x8C91, 0x8C93, 0x8C95, 0x8C96, 0x8C97, 0x8CA1, 0x8CA2,
        0x8CA9, 0x8CE1, 0x8CE2, 0x8CE3, 0x8CE5, 0x8CE9, 0x8CF1, 0x8CF3,
        0x8CF5, 0x8CF6, 0x8CF7, 0x8D41, 0x8D42, 0x8D45, 0x8D51, 0x8D55,
        0x8D57, 0x8D61, 0x8D65, 0x8D69, 0x8D75, 0x8D76, 0x8D7B, 0x8D81,
        0x8DA1, 0x8DA2, 0x8DA5, 0x8DA7, 0x8DA9, 0x8DB1, 0x8DB3, 0x8DB5,
        0x8DB7, 0x8DB8, 0x8DB9, 0x8DC1, 0x8DC2, 0x8DC9, 0x8DD6, 0x8DD7,
        0x8DE1, 0x8DE2, 0x8DF7, 0x8E41, 0x8E45, 0x8E49, 0x8E51, 0x8E53,
        0x8E57, 0x8E61, 0x8E81, 0x8E82, 0x8E85, 0x8E89, 0x8E90, 0x8E91,
        0x8E93, 0x8E95, 0x8E97, 0x8E98, 0x8EA1, 0x8EA9, 0x8EB6, 0x8EB7,
        0x8EC1, 0x8EC2, 0x8EC5, 0x8EC9, 0x8ED1, 0x8ED3, 0x8ED6, 0x8EE1,
        0x8EE5, 0x8EE9, 0x8EF1, 0x8EF3, 0x8F41, 0x8F61, 0x8F62, 0x8F65,
        0x8F67, 0x8F69, 0x8F6B, 0x8F70, 0x8F71, 0x8F73, 0x8F75, 0x8F77,
        0x8F7B, 0x8FA1, 0x8FA2, 0x8FA5, 0x8FA9, 0x8FB1, 0x8FB3, 0x8FB5,
        0x8FB7, 0x9061, 0x9062, 0x9063, 0x9065, 0x9068, 0x9069, 0x906A,
        0x906B, 0x9071, 0x9073, 0x9075, 0x9076, 0x9077, 0x9078, 0x9079,
        0x907B, 0x907D, 0x9081, 0x9082, 0x9085, 0x9089, 0x9091, 0x9093,
        0x9095, 0x9096, 0x9097, 0x90A1, 0x90A2, 0x90A5, 0x90A9, 0x90B1,
        0x90B7, 0x90E1, 0x90E2, 0x90E4, 0x90E5, 0x90E9, 0x90EB, 0x90EC,
        0x90F1, 0x90F3, 0x90F5, 0x90F6, 0x90F7, 0x90FD, 0x9141, 0x9142,
        0x9145, 0x9149, 0x9151, 0x9153, 0x9155, 0x9156, 0x9157, 0x9161,
        0x9162, 0x9165, 0x9169, 0x9171, 0x9173, 0x9176, 0x9177, 0x917A,
        0x9181, 0x9185, 0x91A1, 0x91A2, 0x91A5, 0x91A9, 0x91AB, 0x91B1,
        0x91B3, 0x91B5, 0x91B7, 0x91BC, 0x91BD, 0x91C1, 0x91C5, 0x91C9,
        0x91D6, 0x9241, 0x9245, 0x9249, 0x9251, 0x9253, 0x9255, 0x9261,
        0x9262, 0x9265, 0x9269, 0x9273, 0x9275, 0x9277, 0x9281, 0x9282,
        0x9285, 0x9288, 0x9289, 0x9291, 0x9293, 0x9295, 0x9297, 0x92A1,
        0x92B6, 0x92C1, 0x92E1, 0x92E5, 0x92E9, 0x92F1, 0x92F3, 0x9341,
        0x9342, 0x9349, 0x9351, 0x9353, 0x9357, 0x9361, 0x9362, 0x9365,
        0x9369, 0x936A, 0x936B, 0x9371, 0x9373, 0x9375, 0x9377, 0x9378,
        0x937C, 0x9381, 0x9385, 0x9389, 0x93A1, 0x93A2, 0x93A5, 0x93A9,
        0x93AF, 0x93B1, 0x93B3, 0x93B5, 0x93B7, 0x93BC, 0x9461, 0x9462,
        0x9463, 0x9465, 0x9468, 0x9469, 0x946A, 0x946B, 0x946C, 0x9470,
        0x9471, 0x9473, 0x9475, 0x9476, 0x9477, 0x9478, 0x9479, 0x947D,
        0x9481, 0x9482, 0x9485, 0x9489, 0x9491, 0x9493, 0x9495, 0x9496,
        0x9497, 0x94A1, 0x94E1, 0x94E2, 0x94E3, 0x94E5, 0x94E8, 0x94E9,
        0x94EB, 0x94EC, 0x94F1, 0x94F3, 0x94F5, 0x94F7, 0x94F9, 0x94FC,
        0x9541, 0x9542, 0x9545, 0x9549, 0x9551, 0x9553, 0x9555, 0x9556,
        0x9557, 0x9561, 0x9565, 0x9569, 0x9576, 0x9577, 0x9581, 0x9585,
        0x95A1, 0x95A2, 0x95A5, 0x95A8, 0x95A9, 0x95AB, 0x95AD, 0x95B1,
        0x95B3, 0x95B5, 0x95B7, 0x95B9, 0x95BB, 0x95C1, 0x95C5, 0x95C9,
        0x95E1, 0x95F6, 0x9641, 0x9645, 0x9649, 0x9651, 0x9653, 0x9655,
        0x9661, 0x9681, 0x9682, 0x9685, 0x9689, 0x9691, 0x9693, 0x9695,
        0x9697, 0x96A1, 0x96B6, 0x96C1, 0x96D7, 0x96E1, 0x96E5, 0x96E9,
        0x96F3, 0x96F5, 0x96F7, 0x9741, 0x9745, 0x9749, 0x9751, 0x9757,
        0x9761, 0x9762, 0x9765, 0x9768, 0x9769, 0x976B, 0x9771, 0x9773,
        0x9775, 0x9777, 0x9781, 0x97A1, 0x97A2, 0x97A5, 0x97A8, 0x97A9,
        0x97B1, 0x97B3, 0x97B5, 0x97B6, 0x97B7, 0x97B8, 0x9861, 0x9862,
        0x9865, 0x9869, 0x9871, 0x9873, 0x9875, 0x9876, 0x9877, 0x987D,
        0x9881, 0x9882, 0x9885, 0x9889, 0x9891, 0x9893, 0x9895, 0x9896,
        0x9897, 0x98E1, 0x98E2, 0x98E5, 0x98E9, 0x98EB, 0x98EC, 0x98F1,
        0x98F3, 0x98F5, 0x98F6, 0x98F7, 0x98FD, 0x9941, 0x9942, 0x9945,
        0x9949, 0x9951, 0x9953, 0x9955, 0x9956, 0x9957, 0x9961, 0x9976,
        0x99A1, 0x99A2, 0x99A5, 0x99A9, 0x99B7, 0x99C1, 0x99C9, 0x99E1,
        0x9A41, 0x9A45, 0x9A81, 0x9A82, 0x9A85, 0x9A89, 0x9A90, 0x9A91,
        0x9A97, 0x9AC1, 0x9AE1, 0x9AE5, 0x9AE9, 0x9AF1, 0x9AF3, 0x9AF7,
        0x9B61, 0x9B62, 0x9B65, 0x9B68, 0x9B69, 0x9B71, 0x9B73, 0x9B75,
        0x9B81, 0x9B85, 0x9B89, 0x9B91, 0x9B93, 0x9BA1, 0x9BA5, 0x9BA9,
        0x9BB1, 0x9BB3, 0x9BB5, 0x9BB7, 0x9C61, 0x9C62, 0x9C65, 0x9C69,
        0x9C71, 0x9C73, 0x9C75, 0x9C76, 0x9C77, 0x9C78, 0x9C7C, 0x9C7D,
        0x9C81, 0x9C82, 0x9C85, 0x9C89, 0x9C91, 0x9C93, 0x9C95, 0x9C96,
        0x9C97, 0x9CA1, 0x9CA2, 0x9CA5, 0x9CB5, 0x9CB7, 0x9CE1, 0x9CE2,
        0x9CE5, 0x9CE9, 0x9CF1, 0x9CF3, 0x9CF5, 0x9CF6, 0x9CF7, 0x9CFD,
        0x9D41, 0x9D42, 0x9D45, 0x9D49, 0x9D51, 0x9D53, 0x9D55, 0x9D57,
        0x9D61, 0x9D62, 0x9D65, 0x9D69, 0x9D71, 0x9D73, 0x9D75, 0x9D76,
        0x9D77, 0x9D81, 0x9D85, 0x9D93, 0x9D95, 0x9DA1, 0x9DA2, 0x9DA5,
        0x9DA9, 0x9DB1, 0x9DB3, 0x9DB5, 0x9DB7, 0x9DC1, 0x9DC5, 0x9DD7,
        0x9DF6, 0x9E41, 0x9E45, 0x9E49, 0x9E51, 0x9E53, 0x9E55, 0x9E57,
        0x9E61, 0x9E65, 0x9E69, 0x9E73, 0x9E75, 0x9E77, 0x9E81, 0x9E82,
        0x9E85, 0x9E89, 0x9E91, 0x9E93, 0x9E95, 0x9E97, 0x9EA1, 0x9EB6,
        0x9EC1, 0x9EE1, 0x9EE2, 0x9EE5, 0x9EE9, 0x9EF1, 0x9EF5, 0x9EF7,
        0x9F41, 0x9F42, 0x9F45, 0x9F49, 0x9F51, 0x9F53, 0x9F55, 0x9F57,
        0x9F61, 0x9F62, 0x9F65, 0x9F69, 0x9F71, 0x9F73, 0x9F75, 0x9F77,
        0x9F78, 0x9F7B, 0x9F7C, 0x9FA1, 0x9FA2, 0x9FA5, 0x9FA9, 0x9FB1,
        0x9FB3, 0x9FB5, 0x9FB7, 0xA061, 0xA062, 0xA065, 0xA067, 0xA068,
        0xA069, 0xA06A, 0xA06B, 0xA071, 0xA073, 0xA075, 0xA077, 0xA078,
        0xA07B, 0xA07D, 0xA081, 0xA082, 0xA085, 0xA089, 0xA091, 0xA093,
        0xA095, 0xA096, 0xA097, 0xA098, 0xA0A1, 0xA0A2, 0xA0A9, 0xA0B7,
        0xA0E1, 0xA0E2, 0xA0E5, 0xA0E9, 0xA0EB, 0xA0F1, 0xA0F3, 0xA0F5,
        0xA0F7, 0xA0F8, 0xA0FD, 0xA141, 0xA142, 0xA145, 0xA149, 0xA151,
        0xA153, 0xA155, 0xA156, 0xA157, 0xA161, 0xA162, 0xA165, 0xA169,
        0xA175, 0xA176, 0xA177, 0xA179, 0xA181, 0xA1A1, 0xA1A2, 0xA1A4,
        0xA1A5, 0xA1A9, 0xA1AB, 0xA1B1, 0xA1B3, 0xA1B5, 0xA1B7, 0xA1C1,
        0xA1C5, 0xA1D6, 0xA1D7, 0xA241, 0xA245, 0xA249, 0xA253, 0xA255,
        0xA257, 0xA261, 0xA265, 0xA269, 0xA273, 0xA275, 0xA281, 0xA282,
        0xA283, 0xA285, 0xA288, 0xA289, 0xA28A, 0xA28B, 0xA291, 0xA293,
        0xA295, 0xA297, 0xA29B, 0xA29D, 0xA2A1, 0xA2A5, 0xA2A9, 0xA2B3,
        0xA2B5, 0xA2C1, 0xA2E1, 0xA2E5, 0xA2E9, 0xA341, 0xA345, 0xA349,
        0xA351, 0xA355, 0xA361, 0xA365, 0xA369, 0xA371, 0xA375, 0xA3A1,
        0xA3A2, 0xA3A5, 0xA3A8, 0xA3A9, 0xA3AB, 0xA3B1, 0xA3B3, 0xA3B5,
        0xA3B6, 0xA3B7, 0xA3B9, 0xA3BB, 0xA461, 0xA462, 0xA463, 0xA464,
        0xA465, 0xA468, 0xA469, 0xA46A, 0xA46B, 0xA46C, 0xA471, 0xA473,
        0xA475, 0xA477, 0xA47B, 0xA481, 0xA482, 0xA485, 0xA489, 0xA491,
        0xA493, 0xA495, 0xA496, 0xA497, 0xA49B, 0xA4A1, 0xA4A2, 0xA4A5,
        0xA4B3, 0xA4E1, 0xA4E2, 0xA4E5, 0xA4E8, 0xA4E9, 0xA4EB, 0xA4F1,
        0xA4F3, 0xA4F5, 0xA4F7, 0xA4F8, 0xA541, 0xA542, 0xA545, 0xA548,
        0xA549, 0xA551, 0xA553, 0xA555, 0xA556, 0xA557, 0xA561, 0xA562,
        0xA565, 0xA569, 0xA573, 0xA575, 0xA576, 0xA577, 0xA57B, 0xA581,
        0xA585, 0xA5A1, 0xA5A2, 0xA5A3, 0xA5A5, 0xA5A9, 0xA5B1, 0xA5B3,
        0xA5B5, 0xA5B7, 0xA5C1, 0xA5C5, 0xA5D6, 0xA5E1, 0xA5F6, 0xA641,
        0xA642, 0xA645, 0xA649, 0xA651, 0xA653, 0xA661, 0xA665, 0xA681,
        0xA682, 0xA685, 0xA688, 0xA689, 0xA68A, 0xA68B, 0xA691, 0xA693,
        0xA695, 0xA697, 0xA69B, 0xA69C, 0xA6A1, 0xA6A9, 0xA6B6, 0xA6C1,
        0xA6E1, 0xA6E2, 0xA6E5, 0xA6E9, 0xA6F7, 0xA741, 0xA745, 0xA749,
        0xA751, 0xA755, 0xA757, 0xA761, 0xA762, 0xA765, 0xA769, 0xA771,
        0xA773, 0xA775, 0xA7A1, 0xA7A2, 0xA7A5, 0xA7A9, 0xA7AB, 0xA7B1,
        0xA7B3, 0xA7B5, 0xA7B7, 0xA7B8, 0xA7B9, 0xA861, 0xA862, 0xA865,
        0xA869, 0xA86B, 0xA871, 0xA873, 0xA875, 0xA876, 0xA877, 0xA87D,
        0xA881, 0xA882, 0xA885, 0xA889, 0xA891, 0xA893, 0xA895, 0xA896,
        0xA897, 0xA8A1, 0xA8A2, 0xA8B1, 0xA8E1, 0xA8E2, 0xA8E5, 0xA8E8,
        0xA8E9, 0xA8F1, 0xA8F5, 0xA8F6, 0xA8F7, 0xA941, 0xA957, 0xA961,
        0xA962, 0xA971, 0xA973, 0xA975, 0xA976, 0xA977, 0xA9A1, 0xA9A2,
        0xA9A5, 0xA9A9, 0xA9B1, 0xA9B3, 0xA9B7, 0xAA41, 0xAA61, 0xAA77,
        0xAA81, 0xAA82, 0xAA85, 0xAA89, 0xAA91, 0xAA95, 0xAA97, 0xAB41,
        0xAB57, 0xAB61, 0xAB65, 0xAB69, 0xAB71, 0xAB73, 0xABA1, 0xABA2,
        0xABA5, 0xABA9, 0xABB1, 0xABB3, 0xABB5, 0xABB7, 0xAC61, 0xAC62,
        0xAC64, 0xAC65, 0xAC68, 0xAC69, 0xAC6A, 0xAC6B, 0xAC71, 0xAC73,
        0xAC75, 0xAC76, 0xAC77, 0xAC7B, 0xAC81, 0xAC82, 0xAC85, 0xAC89,
        0xAC91, 0xAC93, 0xAC95, 0xAC96, 0xAC97, 0xACA1, 0xACA2, 0xACA5,
        0xACA9, 0xACB1, 0xACB3, 0xACB5, 0xACB7, 0xACC1, 0xACC5, 0xACC9,
        0xACD1, 0xACD7, 0xACE1, 0xACE2, 0xACE3, 0xACE4, 0xACE5, 0xACE8,
        0xACE9, 0xACEB, 0xACEC, 0xACF1, 0xACF3, 0xACF5, 0xACF6, 0xACF7,
        0xACFC, 0xAD41, 0xAD42, 0xAD45, 0xAD49, 0xAD51, 0xAD53, 0xAD55,
        0xAD56, 0xAD57, 0xAD61, 0xAD62, 0xAD65, 0xAD69, 0xAD71, 0xAD73,
        0xAD75, 0xAD76, 0xAD77, 0xAD81, 0xAD85, 0xAD89, 0xAD97, 0xADA1,
        0xADA2, 0xADA3, 0xADA5, 0xADA9, 0xADAB, 0xADB1, 0xADB3, 0xADB5,
        0xADB7, 0xADBB, 0xADC1, 0xADC2, 0xADC5, 0xADC9, 0xADD7, 0xADE1,
        0xADE5, 0xADE9, 0xADF1, 0xADF5, 0xADF6, 0xAE41, 0xAE45, 0xAE49,
        0xAE51, 0xAE53, 0xAE55, 0xAE61, 0xAE62, 0xAE65, 0xAE69, 0xAE71,
        0xAE73, 0xAE75, 0xAE77, 0xAE81, 0xAE82, 0xAE85, 0xAE88, 0xAE89,
        0xAE91, 0xAE93, 0xAE95, 0xAE97, 0xAE99, 0xAE9B, 0xAE9C, 0xAEA1,
        0xAEB6, 0xAEC1, 0xAEC2, 0xAEC5, 0xAEC9, 0xAED1, 0xAED7, 0xAEE1,
        0xAEE2, 0xAEE5, 0xAEE9, 0xAEF1, 0xAEF3, 0xAEF5, 0xAEF7, 0xAF41,
        0xAF42, 0xAF49, 0xAF51, 0xAF55, 0xAF57, 0xAF61, 0xAF62, 0xAF65,
        0xAF69, 0xAF6A, 0xAF71, 0xAF73, 0xAF75, 0xAF77, 0xAFA1, 0xAFA2,
        0xAFA5, 0xAFA8, 0xAFA9, 0xAFB0, 0xAFB1, 0xAFB3, 0xAFB5, 0xAFB7,
        0xAFBC, 0xB061, 0xB062, 0xB064, 0xB065, 0xB069, 0xB071, 0xB073,
        0xB076, 0xB077, 0xB07D, 0xB081, 0xB082, 0xB085, 0xB089, 0xB091,
        0xB093, 0xB096, 0xB097, 0xB0B7, 0xB0E1, 0xB0E2, 0xB0E5, 0xB0E9,
        0xB0EB, 0xB0F1, 0xB0F3, 0xB0F6, 0xB0F7, 0xB141, 0xB145, 0xB149,
        0xB157, 0xB1A1, 0xB1A2, 0xB1A5, 0xB1A8, 0xB1A9, 0xB1AB, 0xB1B1,
        0xB1B3, 0xB1B7, 0xB1C1, 0xB1C2, 0xB1C5, 0xB1D6, 0xB1E1, 0xB1F6,
        0xB241, 0xB245, 0xB249, 0xB251, 0xB253, 0xB261, 0xB281, 0xB282,
        0xB285, 0xB289, 0xB291, 0xB293, 0xB297, 0xB2A1, 0xB2B6, 0xB2C1,
        0xB2E1, 0xB2E5, 0xB357, 0xB361, 0xB362, 0xB365, 0xB369, 0xB36B,
        0xB370, 0xB371, 0xB373, 0xB381, 0xB385, 0xB389, 0xB391, 0xB3A1,
        0xB3A2, 0xB3A5, 0xB3A9, 0xB3B1, 0xB3B3, 0xB3B5, 0xB3B7, 0xB461,
        0xB462, 0xB465, 0xB466, 0xB467, 0xB469, 0xB46A, 0xB46B, 0xB470,
        0xB471, 0xB473, 0xB475, 0xB476, 0xB477, 0xB47B, 0xB47C, 0xB481,
        0xB482, 0xB485, 0xB489, 0xB491, 0xB493, 0xB495, 0xB496, 0xB497,
        0xB4A1, 0xB4A2, 0xB4A5, 0xB4A9, 0xB4AC, 0xB4B1, 0xB4B3, 0xB4B5,
        0xB4B7, 0xB4BB, 0xB4BD, 0xB4C1, 0xB4C5, 0xB4C9, 0xB4D3, 0xB4E1,
        0xB4E2, 0xB4E5, 0xB4E6, 0xB4E8, 0xB4E9, 0xB4EA, 0xB4EB, 0xB4F1,
        0xB4F3, 0xB4F4, 0xB4F5, 0xB4F6, 0xB4F7, 0xB4F8, 0xB4FA, 0xB4FC,
        0xB541, 0xB542, 0xB545, 0xB549, 0xB551, 0xB553, 0xB555, 0xB557,
        0xB561, 0xB562, 0xB563, 0xB565, 0xB569, 0xB56B, 0xB56C, 0xB571,
        0xB573, 0xB574, 0xB575, 0xB576, 0xB577, 0xB57B, 0xB57C, 0xB57D,
        0xB581, 0xB585, 0xB589, 0xB591, 0xB593, 0xB595, 0xB596, 0xB5A1,
        0xB5A2, 0xB5A5, 0xB5A9, 0xB5AA, 0xB5AB, 0xB5AD, 0xB5B0, 0xB5B1,
        0xB5B3, 0xB5B5, 0xB5B7, 0xB5B9, 0xB5C1, 0xB5C2, 0xB5C5, 0xB5C9,
        0xB5D1, 0xB5D3, 0xB5D5, 0xB5D6, 0xB5D7, 0xB5E1, 0xB5E2, 0xB5E5,
        0xB5F1, 0xB5F5, 0xB5F7, 0xB641, 0xB642, 0xB645, 0xB649, 0xB651,
        0xB653, 0xB655, 0xB657, 0xB661, 0xB662, 0xB665, 0xB669, 0xB671,
        0xB673, 0xB675, 0xB677, 0xB681, 0xB682, 0xB685, 0xB689, 0xB68A,
        0xB68B, 0xB691, 0xB693, 0xB695, 0xB697, 0xB6A1, 0xB6A2, 0xB6A5,
        0xB6A9, 0xB6B1, 0xB6B3, 0xB6B6, 0xB6B7, 0xB6C1, 0xB6C2, 0xB6C5,
        0xB6C9, 0xB6D1, 0xB6D3, 0xB6D7, 0xB6E1, 0xB6E2, 0xB6E5, 0xB6E9,
        0xB6F1, 0xB6F3, 0xB6F5, 0xB6F7, 0xB741, 0xB742, 0xB745, 0xB749,
        0xB751, 0xB753, 0xB755, 0xB757, 0xB759, 0xB761, 0xB762, 0xB765,
        0xB769, 0xB76F, 0xB771, 0xB773, 0xB775, 0xB777, 0xB778, 0xB779,
        0xB77A, 0xB77B, 0xB77C, 0xB77D, 0xB781, 0xB785, 0xB789, 0xB791,
        0xB795, 0xB7A1, 0xB7A2, 0xB7A5, 0xB7A9, 0xB7AA, 0xB7AB, 0xB7B0,
        0xB7B1, 0xB7B3, 0xB7B5, 0xB7B6, 0xB7B7, 0xB7B8, 0xB7BC, 0xB861,
        0xB862, 0xB865, 0xB867, 0xB868, 0xB869, 0xB86B, 0xB871, 0xB873,
        0xB875, 0xB876, 0xB877, 0xB878, 0xB881, 0xB882, 0xB885, 0xB889,
        0xB891, 0xB893, 0xB895, 0xB896, 0xB897, 0xB8A1, 0xB8A2, 0xB8A5,
        0xB8A7, 0xB8A9, 0xB8B1, 0xB8B7, 0xB8C1, 0xB8C5, 0xB8C9, 0xB8E1,
        0xB8E2, 0xB8E5, 0xB8E9, 0xB8EB, 0xB8F1, 0xB8F3, 0xB8F5, 0xB8F7,
        0xB8F8, 0xB941, 0xB942, 0xB945, 0xB949, 0xB951, 0xB953, 0xB955,
        0xB957, 0xB961, 0xB965, 0xB969, 0xB971, 0xB973, 0xB976, 0xB977,
        0xB981, 0xB9A1, 0xB9A2, 0xB9A5, 0xB9A9, 0xB9AB, 0xB9B1, 0xB9B3,
        0xB9B5, 0xB9B7, 0xB9B8, 0xB9B9, 0xB9BD, 0xB9C1, 0xB9C2, 0xB9C9,
        0xB9D3, 0xB9D5, 0xB9D7, 0xB9E1, 0xB9F6, 0xB9F7, 0xBA41, 0xBA45,
        0xBA49, 0xBA51, 0xBA53, 0xBA55, 0xBA57, 0xBA61, 0xBA62, 0xBA65,
        0xBA77, 0xBA81, 0xBA82, 0xBA85, 0xBA89, 0xBA8A, 0xBA8B, 0xBA91,
        0xBA93, 0xBA95, 0xBA97, 0xBAA1, 0xBAB6, 0xBAC1, 0xBAE1, 0xBAE2,
        0xBAE5, 0xBAE9, 0xBAF1, 0xBAF3, 0xBAF5, 0xBB41, 0xBB45, 0xBB49,
        0xBB51, 0xBB61, 0xBB62, 0xBB65, 0xBB69, 0xBB71, 0xBB73, 0xBB75,
        0xBB77, 0xBBA1, 0xBBA2, 0xBBA5, 0xBBA8, 0xBBA9, 0xBBAB, 0xBBB1,
        0xBBB3, 0xBBB5, 0xBBB7, 0xBBB8, 0xBBBB, 0xBBBC, 0xBC61, 0xBC62,
        0xBC65, 0xBC67, 0xBC69, 0xBC6C, 0xBC71, 0xBC73, 0xBC75, 0xBC76,
        0xBC77, 0xBC81, 0xBC82, 0xBC85, 0xBC89, 0xBC91, 0xBC93, 0xBC95,
        0xBC96, 0xBC97, 0xBCA1, 0xBCA5, 0xBCB7, 0xBCE1, 0xBCE2, 0xBCE5,
        0xBCE9, 0xBCF1, 0xBCF3, 0xBCF5, 0xBCF6, 0xBCF7, 0xBD41, 0xBD57,
        0xBD61, 0xBD76, 0xBDA1, 0xBDA2, 0xBDA5, 0xBDA9, 0xBDB1, 0xBDB3,
        0xBDB5, 0xBDB7, 0xBDB9, 0xBDC1, 0xBDC2, 0xBDC9, 0xBDD6, 0xBDE1,
        0xBDF6, 0xBE41, 0xBE45, 0xBE49, 0xBE51, 0xBE53, 0xBE77, 0xBE81,
        0xBE82, 0xBE85, 0xBE89, 0xBE91, 0xBE93, 0xBE97, 0xBEA1, 0xBEB6,
        0xBEB7, 0xBEE1, 0xBF41, 0xBF61, 0xBF71, 0xBF75, 0xBF77, 0xBFA1,
        0xBFA2, 0xBFA5, 0xBFA9, 0xBFB1, 0xBFB3, 0xBFB7, 0xBFB8, 0xBFBD,
        0xC061, 0xC062, 0xC065, 0xC067, 0xC069, 0xC071, 0xC073, 0xC075,
        0xC076, 0xC077, 0xC078, 0xC081, 0xC082, 0xC085, 0xC089, 0xC091,
        0xC093, 0xC095, 0xC096, 0xC097, 0xC0A1, 0xC0A5, 0xC0A7, 0xC0A9,
        0xC0B1, 0xC0B7, 0xC0E1, 0xC0E2, 0xC0E5, 0xC0E9, 0xC0F1, 0xC0F3,
        0xC0F5, 0xC0F6, 0xC0F7, 0xC141, 0xC142, 0xC145, 0xC149, 0xC151,
        0xC153, 0xC155, 0xC157, 0xC161, 0xC165, 0xC176, 0xC181, 0xC185,
        0xC197, 0xC1A1, 0xC1A2, 0xC1A5, 0xC1A9, 0xC1B1, 0xC1B3, 0xC1B5,
        0xC1B7, 0xC1C1, 0xC1C5, 0xC1C9, 0xC1D7, 0xC241, 0xC245, 0xC249,
        0xC251, 0xC253, 0xC255, 0xC257, 0xC261, 0xC271, 0xC281, 0xC282,
        0xC285, 0xC289, 0xC291, 0xC293, 0xC295, 0xC297, 0xC2A1, 0xC2B6,
        0xC2C1, 0xC2C5, 0xC2E1, 0xC2E5, 0xC2E9, 0xC2F1, 0xC2F3, 0xC2F5,
        0xC2F7, 0xC341, 0xC345, 0xC349, 0xC351, 0xC357, 0xC361, 0xC362,
        0xC365, 0xC369, 0xC371, 0xC373, 0xC375, 0xC377, 0xC3A1, 0xC3A2,
        0xC3A5, 0xC3A8, 0xC3A9, 0xC3AA, 0xC3B1, 0xC3B3, 0xC3B5, 0xC3B7,
        0xC461, 0xC462, 0xC465, 0xC469, 0xC471, 0xC473, 0xC475, 0xC477,
        0xC481, 0xC482, 0xC485, 0xC489, 0xC491, 0xC493, 0xC495, 0xC496,
        0xC497, 0xC4A1, 0xC4A2, 0xC4B7, 0xC4E1, 0xC4E2, 0xC4E5, 0xC4E8,
        0xC4E9, 0xC4F1, 0xC4F3, 0xC4F5, 0xC4F6, 0xC4F7, 0xC541, 0xC542,
        0xC545, 0xC549, 0xC551, 0xC553, 0xC555, 0xC557, 0xC561, 0xC565,
        0xC569, 0xC571, 0xC573, 0xC575, 0xC576, 0xC577, 0xC581, 0xC5A1,
        0xC5A2, 0xC5A5, 0xC5A9, 0xC5B1, 0xC5B3, 0xC5B5, 0xC5B7, 0xC5C1,
        0xC5C2, 0xC5C5, 0xC5C9, 0xC5D1, 0xC5D7, 0xC5E1, 0xC5F7, 0xC641,
        0xC649, 0xC661, 0xC681, 0xC682, 0xC685, 0xC689, 0xC691, 0xC693,
        0xC695, 0xC697, 0xC6A1, 0xC6A5, 0xC6A9, 0xC6B7, 0xC6C1, 0xC6D7,
        0xC6E1, 0xC6E2, 0xC6E5, 0xC6E9, 0xC6F1, 0xC6F3, 0xC6F5, 0xC6F7,
        0xC741, 0xC745, 0xC749, 0xC751, 0xC761, 0xC762, 0xC765, 0xC769,
        0xC771, 0xC773, 0xC777, 0xC7A1, 0xC7A2, 0xC7A5, 0xC7A9, 0xC7B1,
        0xC7B3, 0xC7B5, 0xC7B7, 0xC861, 0xC862, 0xC865, 0xC869, 0xC86A,
        0xC871, 0xC873, 0xC875, 0xC876, 0xC877, 0xC881, 0xC882, 0xC885,
        0xC889, 0xC891, 0xC893, 0xC895, 0xC896, 0xC897, 0xC8A1, 0xC8B7,
        0xC8E1, 0xC8E2, 0xC8E5, 0xC8E9, 0xC8EB, 0xC8F1, 0xC8F3, 0xC8F5,
        0xC8F6, 0xC8F7, 0xC941, 0xC942, 0xC945, 0xC949, 0xC951, 0xC953,
        0xC955, 0xC957, 0xC961, 0xC965, 0xC976, 0xC981, 0xC985, 0xC9A1,
        0xC9A2, 0xC9A5, 0xC9A9, 0xC9B1, 0xC9B3, 0xC9B5, 0xC9B7, 0xC9BC,
        0xC9C1, 0xC9C5, 0xC9E1, 0xCA41, 0xCA45, 0xCA55, 0xCA57, 0xCA61,
        0xCA81, 0xCA82, 0xCA85, 0xCA89, 0xCA91, 0xCA93, 0xCA95, 0xCA97,
        0xCAA1, 0xCAB6, 0xCAC1, 0xCAE1, 0xCAE2, 0xCAE5, 0xCAE9, 0xCAF1,
        0xCAF3, 0xCAF7, 0xCB41, 0xCB45, 0xCB49, 0xCB51, 0xCB57, 0xCB61,
        0xCB62, 0xCB65, 0xCB68, 0xCB69, 0xCB6B, 0xCB71, 0xCB73, 0xCB75,
        0xCB81, 0xCB85, 0xCB89, 0xCB91, 0xCB93, 0xCBA1, 0xCBA2, 0xCBA5,
        0xCBA9, 0xCBB1, 0xCBB3, 0xCBB5, 0xCBB7, 0xCC61, 0xCC62, 0xCC63,
        0xCC65, 0xCC69, 0xCC6B, 0xCC71, 0xCC73, 0xCC75, 0xCC76, 0xCC77,
        0xCC7B, 0xCC81, 0xCC82, 0xCC85, 0xCC89, 0xCC91, 0xCC93, 0xCC95,
        0xCC96, 0xCC97, 0xCCA1, 0xCCA2, 0xCCE1, 0xCCE2, 0xCCE5, 0xCCE9,
        0xCCF1, 0xCCF3, 0xCCF5, 0xCCF6, 0xCCF7, 0xCD41, 0xCD42, 0xCD45,
        0xCD49, 0xCD51, 0xCD53, 0xCD55, 0xCD57, 0xCD61, 0xCD65, 0xCD69,
        0xCD71, 0xCD73, 0xCD76, 0xCD77, 0xCD81, 0xCD89, 0xCD93, 0xCD95,
        0xCDA1, 0xCDA2, 0xCDA5, 0xCDA9, 0xCDB1, 0xCDB3, 0xCDB5, 0xCDB7,
        0xCDC1, 0xCDD7, 0xCE41, 0xCE45, 0xCE61, 0xCE65, 0xCE69, 0xCE73,
        0xCE75, 0xCE81, 0xCE82, 0xCE85, 0xCE88, 0xCE89, 0xCE8B, 0xCE91,
        0xCE93, 0xCE95, 0xCE97, 0xCEA1, 0xCEB7, 0xCEE1, 0xCEE5, 0xCEE9,
        0xCEF1, 0xCEF5, 0xCF41, 0xCF45, 0xCF49, 0xCF51, 0xCF55, 0xCF57,
        0xCF61, 0xCF65, 0xCF69, 0xCF71, 0xCF73, 0xCF75, 0xCFA1, 0xCFA2,
        0xCFA5, 0xCFA9, 0xCFB1, 0xCFB3, 0xCFB5, 0xCFB7, 0xD061, 0xD062,
        0xD065, 0xD069, 0xD06E, 0xD071, 0xD073, 0xD075, 0xD077, 0xD081,
        0xD082, 0xD085, 0xD089, 0xD091, 0xD093, 0xD095, 0xD096, 0xD097,
        0xD0A1, 0xD0B7, 0xD0E1, 0xD0E2, 0xD0E5, 0xD0E9, 0xD0EB, 0xD0F1,
        0xD0F3, 0xD0F5, 0xD0F7, 0xD141, 0xD142, 0xD145, 0xD149, 0xD151,
        0xD153, 0xD155, 0xD157, 0xD161, 0xD162, 0xD165, 0xD169, 0xD171,
        0xD173, 0xD175, 0xD176, 0xD177, 0xD181, 0xD185, 0xD189, 0xD193,
        0xD1A1, 0xD1A2, 0xD1A5, 0xD1A9, 0xD1AE, 0xD1B1, 0xD1B3, 0xD1B5,
        0xD1B7, 0xD1BB, 0xD1C1, 0xD1C2, 0xD1C5, 0xD1C9, 0xD1D5, 0xD1D7,
        0xD1E1, 0xD1E2, 0xD1E5, 0xD1F5, 0xD1F7, 0xD241, 0xD242, 0xD245,
        0xD249, 0xD253, 0xD255, 0xD257, 0xD261, 0xD265, 0xD269, 0xD273,
        0xD275, 0xD281, 0xD282, 0xD285, 0xD289, 0xD28E, 0xD291, 0xD295,
        0xD297, 0xD2A1, 0xD2A5, 0xD2A9, 0xD2B1, 0xD2B7, 0xD2C1, 0xD2C2,
        0xD2C5, 0xD2C9, 0xD2D7, 0xD2E1, 0xD2E2, 0xD2E5, 0xD2E9, 0xD2F1,
        0xD2F3, 0xD2F5, 0xD2F7, 0xD341, 0xD342, 0xD345, 0xD349, 0xD351,
        0xD355, 0xD357, 0xD361, 0xD362, 0xD365, 0xD367, 0xD368, 0xD369,
        0xD36A, 0xD371, 0xD373, 0xD375, 0xD377, 0xD37B, 0xD381, 0xD385,
        0xD389, 0xD391, 0xD393, 0xD397, 0xD3A1, 0xD3A2, 0xD3A5, 0xD3A9,
        0xD3B1, 0xD3B3, 0xD3B5, 0xD3B7
};


#endif 
